<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'auth/index';
$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;

/* CUSTOM ROUTES */
$route['login'] = 'auth/index';
$route['login-redirect'] = 'auth/login';
$route['change-password'] = 'auth/change_password';

$route['dashboard'] = 'dashboard/index';
$route['college-dashboard'] = 'college/dashboard';
$route['student-dashboard'] = 'student/dashboard';

$route['categories'] = 'category/index';
$route['add-categoty'] = 'category/create';
$route['edit-categoty/(:num)'] = 'category/edit/$1';

$route['subcategories'] = 'subcategory/index';
$route['subcategories/(:any)'] = 'subcategory/index/$1';
$route['add-subcategory'] = 'subcategory/create';
$route['edit-subcategory/(:num)'] = 'subcategory/edit/$1';

$route['colleges'] = 'college/index';
$route['colleges/(:any)'] = 'college/index/$1';
$route['add-college'] = 'college/create';
$route['edit-college/(:num)'] = 'college/edit/$1';

//$route['students'] = 'students/index';
//$route['students/(:any)'] = 'students/index/$1';    
$route['add-student'] = 'student/create';
$route['edit-student/(:num)'] = 'student/edit/$1';

//$route['business'] = 'business/listing';
//$route['business/(:any)'] = 'business/listing/$1';
$route['business-listing'] = 'adminBusiness/listing';
$route['business-listing/(:any)/(:any)'] = 'adminBusiness/listing/$1/$2';
$route['business-listing/(:any)/(:any)/(:any)'] = 'adminBusiness/listing/$1/$2/$3';
$route['add-business'] = 'adminBusiness/create';
$route['add-business/(:any)/(:any)'] = 'adminBusiness/create/$1/$2';
$route['store-business/(:any)/(:any)'] = 'adminBusiness/store/$1/$2';
$route['store-business'] = 'adminBusiness/store';
$route['edit-business/(:any)/(:any)/(:any)'] = 'adminBusiness/edit/$1/$2/$3';
$route['update-business/(:any)/(:any)/(:any)'] = 'adminBusiness/update/$1/$2/$3';
$route['edit-business/(:any)'] = 'adminBusiness/edit/$1';
$route['update-business/(:any)'] = 'adminBusiness/update/$1';
$route['change-business-status/(:any)/(:any)'] = 'adminBusiness/change_status/$1/$2';
$route['change-business-status/(:any)/(:any)/(:any)'] = 'adminBusiness/change_status/$1/$2/$3';
$route['extend-business-plan/(:any)/(:any)/(:any)'] = 'adminBusiness/extend_business_plan/$1/$2/$3';
$route['extend-business-plan/(:any)/(:any)'] = 'adminBusiness/extend_business_plan/$1/$2';
$route['admin-business-reviews/(:any)'] = 'adminBusiness/admin_business_reviews/$1';
$route['admin-business-reviews/(:any)/(:any)'] = 'adminBusiness/admin_business_reviews/$1/$2';
$route['delete-business-review/(:any)/(:any)'] = 'adminBusiness/delete_business_review/$1/$2';

$route['business/(:any)'] = 'Business/show/$1';
$route['business/browse/businesses'] = 'Business/browse_businesses';
$route['business/(:any)/reviews'] = 'Business/business_reviews/$1';
$route['business/(:any)/embedded_reviews'] = 'Business/embedded_reviews/$1';
$route['logout'] = 'auth/logout';


