<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class AdminBusiness extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        //check_admin_and_college();
        $data['web_title'] = 'Admin | Business';
        $this->load->vars($data);
        check_session();
    }
    public function valid_url($str) {
        return (filter_var($str, FILTER_VALIDATE_URL) !== FALSE);
    }
    function listing($created_id='',$slug='')
    {
        $user_id = session('bs_user_id');
        $data['created_id'] = $created_id;
        if($created_id=='' && $slug=='')
        {
            $url = base_url() . "adminBusiness/listing";
            $uri_segment = 2;
            $page = ($this->uri->segment($uri_segment)) ? $this->uri->segment($uri_segment) : 0;
            if($page != 0) $page = $this->per_page * ($page-1);
            $total_rows = $this->general->get_details_by_multi_columns_pagination_array('business',array())->num_rows();

            $items = $this->general->get_details_by_multi_columns_pagination_array('business',array(),$page,$this->per_page)->result();
            
        }else{
            $url = base_url() . "adminBusiness/listing/".$created_id."/".$slug;
            $uri_segment = 4;
            $page = ($this->uri->segment($uri_segment)) ? $this->uri->segment($uri_segment) : 0;
            if($page != 0) $page = $this->per_page * ($page-1);
            $total_rows = $this->general->get_details_by_multi_columns_pagination_array('business',array('user_id'=>$created_id))->num_rows();
            $items = $this->general->get_details_by_multi_columns_pagination_array('business',array('user_id'=>$created_id),$page,$this->per_page)->result();
        }
        if(!empty($items))
        {
            $i=1;
            foreach ($items as $r)
            {
                $data['items'][$i]['row'] = $r;
                $business_created = $r->subscription_datetime;
                $subscription = $r->subscription_type;
                $plan_expired = strtotime("+$subscription day",strtotime($business_created));
                $data['items'][$i]['free_plan_expired'] = date('M d, Y H:i', $plan_expired);
                //$data['items'][$i]['free_plan_expired'] = date('Y-m-d H:i:s', $plan_expired);
                $expired_plan_datetime = date('Y-m-d H:i:s',$plan_expired);
                if(strtotime(date('Y-m-d H:i:s')) > strtotime($expired_plan_datetime))
                { 
                    $data['items'][$i]['is_free_plan_expired'] = 1;
                }else{
                    $data['items'][$i]['is_free_plan_expired'] = 0;
                }
                $i++;
            }
        }else{
           $data['items'] = array(); 
        }
       //echo $this->db->last_query();
        //echo '<pre>';print_r($data);echo '</pre>';exit;
        $data['paging'] = globalPagination($url, $total_rows, $this->per_page, $uri_segment);
        $data['page'] = ($this->uri->segment($uri_segment)) ? $this->uri->segment($uri_segment) : 1;
        $data['per_page'] = $this->per_page;
            
        $student_details = $this->general->get_details_by_multi_columns('users',array('id'=>$created_id))->row();
        $data['slug'] = $slug;
        $data['title'] = 'Business List';
        
        if($created_id=='' && $slug==''){
            $data['beadcrum_title'] = 'Admin';
        }else{
            $data['beadcrum_title'] = session('college_name') . ' &nbsp;&nbsp; > &nbsp;&nbsp;'   .$student_details->name;
        }
        
        $data['beadcrum_sub_title'] = 'Business List';
        $data['active']= 'business';
        $data['page']= 'admin/business/index';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create($created_id='',$slug='')
    {
        
        $categories = $this->general->get_details_by_multi_columns('categories',array('active'=>1))->result();
        $states = $this->config->item('states');
        
        $data['created_id'] = $created_id;
        $data['slug'] = $slug;
        //$data['slug'] = $this->general->get_details_by_multi_columns('colleges',array('slug'=>$slug))->row()->id;
        $data['states'] = $states;
        $data['categories']=$categories;
        $data['users'] = $this->general->get_details_by_multi_columns('users',array('active'=>1))->result();
        $data['title'] = 'Create New Business';
        $data['beadcrum_title'] = session('college_name');
        $data['beadcrum_sub_title'] = 'Create Business';
        $data['active']= 'business';
        $data['page']= 'admin/business/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
       
    }
    
    function store($created_id='',$slug='')
    {
        $data['created_id'] = $created_id;
        
        if($created_id=='')
        {
            $this->form_validation->set_rules('user_id','User','trim|required');
        }
        $this->form_validation->set_rules('business_name','Business name','trim|required|is_unique[business.business_name]');
        $this->form_validation->set_rules('owner','Business Owner','trim|required');
        $this->form_validation->set_rules('description','Business name','trim|required');
        $this->form_validation->set_rules('notes','Notes','trim|required');
        $this->form_validation->set_rules('primary_phone','Primary Phone','trim|required|numeric');
        $this->form_validation->set_rules('secondary_phone','Secondary Phone','trim|numeric');
        $this->form_validation->set_rules('other_contact','Other Contact','trim|required');
        $this->form_validation->set_rules('category_id','Category','required');
        $this->form_validation->set_rules('other_contact','Other_ Contact','trim|required');
        $this->form_validation->set_rules('address_1','Address Line 1','trim|required');
        $this->form_validation->set_rules('address_2','Address Line 2','trim|required');
        $this->form_validation->set_rules('website','Website','required|callback_valid_url');
        $this->form_validation->set_rules('city','City','trim|required');
        $this->form_validation->set_rules('state','State','trim|required');
        $this->form_validation->set_rules('zipcode','Zipcode','trim|required|min_length[5]|alpha_numeric_spaces');
        $this->form_validation->set_rules('subscription_type','Subscription type','trim|required|in_list[7,30,60]');
        $this->form_validation->set_rules('email', 'Email', 'trim|required|valid_email');
        if (empty($_FILES['banner']['name']))
        {
           $this->form_validation->set_rules('banner', 'Banner', 'required');
        }
        if (empty($_FILES['logo']['name']))
        {
          $this->form_validation->set_rules('logo', 'Logo', 'required');
        }
        
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'add-business/'.$created_id.'/'.$slug);
        }else{
            
            $form_data=array();
            
            foreach($this->input_params as $key=>$r)
            {
                $form_data["$key"] = $r;
            }
            $other_data['verify_code'] = randomPassword();
            
            if(isset($this->input_params['user_id']) && $this->input_params['user_id'] != 0)
            {
                $other_data['created_by'] = $this->general->get_details_by_multi_columns('users',array('id'=>$this->input_params['user_id']))->row()->role;
            }else{
                //$other_data['college_id'] = $this->general->get_details_by_multi_columns('colleges',array('slug'=>$slug))->row()->id;
                $other_data['user_id'] = (session('role')==0) ? 0 : session('bs_user_id');
                $other_data['created_by'] = (session('role'));
            }
            
            $other_data['active'] = 0;
            
            $other_data['subscription_datetime'] = date('Y-m-d H:i:s');
            $other_data['created'] = date('Y-m-d H:i:s');
            
            //echo '<pre>';print_r($_FILES);
            $banner_imagr = upload_image('banners','banner',1200,300);
            //echo '<pre>';print_r($banner_imagr);
            if(!empty($banner_imagr['error']))
            {
                $this->session->set_flashdata('post_data',$this->input_params);
                $this->session->set_flashdata('error',$banner_imagr['error']);
                redirect(base_url().'add-business/'.$created_id.'/'.$slug);
            }
            $upload_filename=$banner_imagr['file_name'];
            $other_data['banner']='banners/'.$upload_filename;
            
            $logo_imagr = upload_image('logo','logo',300,150);
            if(!empty($logo_imagr['error']))
            {
                $this->session->set_flashdata('post_data',$this->input_params);
                $this->session->set_flashdata('error',$logo_imagr['error']);
                redirect(base_url().'add-business/'.$created_id.'/'.$slug);
            }
            $upload_logo=$logo_imagr['file_name'];
            $other_data['logo']='logo/'.$upload_logo;
            //array_push( $form_data, $other_data );
            $form_data = array_merge($form_data,$other_data);
            
            $business_id = $this->general->insert('business', $form_data); 
            if($business_id)
            {
                $slug_data['slug'] = create_slug($business_id, $this->input_params['business_name'],'business');
                $slug_data['active'] = 1;
                $this->general->update('business','id',$business_id,$slug_data);
                
                ///// send email to business user /////////
                //send_system_email($_POST['email'],'',$message);
                $this->session->set_flashdata('success','Business added successfully.');
                redirect(base_url().'business-listing/'.$created_id.'/'.$slug);
               
            }else{
                $this->session->set_flashdata('error','There is some problem to add student. Please try again');
               redirect(base_url().'add-business/'.$created_id.'/'.$slug);
            }
        }
    }
    
    function edit($id,$created_id='',$slug='')
    {
        $data['created_id'] = $created_id;
        $business = $this->general->get_details_by_multi_columns('business',array('id'=>$id))->row();
        if($business)
        {
            $categories = $this->general->get_details_by_multi_columns('categories',array('active'=>1))->result();
            $states = $this->config->item('states');
        
            $data['states'] = $states;
            $data['categories']=$categories;
            $data['users'] = $this->general->get_details_by_multi_columns('users',array('active'=>1))->result();
            $data['slug'] = $slug;
            $data['row']=$business;
            
            $data['is_edit']= '1';
            $data['title'] = 'Edit Business';
            $data['beadcrum_title'] = 'Edit Business';
            $data['beadcrum_sub_title'] = 'Edit Business';
            $data['active']= 'business';
            $data['page']= 'admin/business/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id,$created_id='',$slug='')
    {
        
        $data['created_id'] = $created_id;
        
        if($created_id=='')
        {
            $this->form_validation->set_rules('user_id','User','trim|required');
        }
        $this->form_validation->set_rules('owner','Business Owner','trim|required');
        $this->form_validation->set_rules('description','Business name','trim|required');
        $this->form_validation->set_rules('notes','Notes','trim|required');
        $this->form_validation->set_rules('primary_phone','Primary Phone','trim|required|numeric');
        $this->form_validation->set_rules('secondary_phone','Secondary Phone','trim|numeric');
        $this->form_validation->set_rules('other_contact','Other Contact','trim|required');
        $this->form_validation->set_rules('category_id','Category','required');
        $this->form_validation->set_rules('other_contact','Other_ Contact','trim|required');
        $this->form_validation->set_rules('address_1','Address Line 1','trim|required');
        $this->form_validation->set_rules('address_2','Address Line 2','trim|required');
        $this->form_validation->set_rules('website','Website','required|callback_valid_url');
        $this->form_validation->set_rules('city','City','trim|required');
        $this->form_validation->set_rules('state','State','trim|required');
        $this->form_validation->set_rules('zipcode','Zipcode','trim|required|min_length[5]|alpha_numeric_spaces');
        //$this->form_validation->set_rules('subscription_type','Subscription type','trim|required|in_list[7,30,60]');
        $this->form_validation->set_rules('email', 'Email', 'trim|required|valid_email');
        
        
        $business = $this->general->get_details_by_multi_columns('business',array('id'=>$id))->row();
        $is_business_unique =  '';
        if($this->input_params['business_name'] != $business->business_name) {
            $is_business_unique =  '|is_unique[business.business_name]';
        } 
        $this->form_validation->set_rules('business_name','Business name','trim|required'.$is_business_unique);
        
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'edit-business/'.$id.'/'.$created_id.'/'.$slug);
        }else{
            $form_data=array();
            
            foreach($this->input_params as $key=>$r)
            {
                $form_data["$key"] = $r;
            }
            
            if(isset($this->input_params['user_id']))
            {
                if($this->input_params['user_id'] != 0)
                {
                    $other_data['created_by'] = $this->general->get_details_by_multi_columns('users',array('id'=>$this->input_params['user_id']))->row()->role;
                }else{
                    $other_data['created_by'] = 0;
                }
            }
            
            $other_data['last_modified'] = date('Y-m-d H:i:s');
            if(isset($_FILES['banner']['name']) && $_FILES['banner']['name']!=""){
                $banner_imagr = upload_image('banners','banner','1200','300');
                if(!empty($banner_imagr['error']))
                {
                    $this->session->set_flashdata('post_data',$this->input_params);
                    $this->session->set_flashdata('error',$banner_imagr['error']);
                    redirect(base_url().'edit-business/'.$id.'/'.$created_id.'/'.$slug);
                }
                $upload_filename=$banner_imagr['file_name'];
                $other_data['banner']='banners/'.$upload_filename;
            }
            
            if(isset($_FILES['logo']['name']) && $_FILES['logo']['name']!=""){
                $logo_imagr = upload_image('logo','logo','300','150');
                if(!empty($logo_imagr['error']))
                {
                    $this->session->set_flashdata('post_data',$this->input_params);
                    $this->session->set_flashdata('error',$logo_imagr['error']);
                    redirect(base_url().'edit-business/'.$id.'/'.$created_id.'/'.$slug);
                }
                $upload_logo=$logo_imagr['file_name'];
                $other_data['logo']='logo/'.$upload_logo;
            }
            //array_push( $form_data, $other_data );
            $other_data['slug'] = create_slug($id, $this->input_params['business_name'],'business');
            $form_data = array_merge($form_data,$other_data);
            $this->general->update('business','id',$id,$form_data);
            
            $this->session->set_flashdata('success','Business updated successfully.');
            redirect(base_url().'business-listing/'.$created_id.'/'.$slug);
        }
    }
    
    function change_status($id,$status,$slug='')
    {
        if($id)
        {
            $data['active'] = $status;
            $this->general->update('business','id',$id,$data);
            redirect_back();
        }else{
           abort(404); 
        }
    }
    function extend_business_plan($id,$days,$slug='')
    {
        if($id)
        {
            $business = $this->general->get_details_by_multi_columns('business',array('id'=>$id))->row();
            $plan_extended = strtotime("+$days day",strtotime($business->subscription_datetime));
            $data['subscription_datetime'] = date('Y-m-d H:i:s', $plan_extended);
            $this->general->update('business','id',$id,$data);
            //print_r($data);
            redirect_back();
        }else{
           abort(404); 
        }
    }
    
    function admin_business_reviews($id)
    {
        $url = base_url() . "admin-business-reviews/".$id;
        $uri_segment = 3;
        $page = ($this->uri->segment($uri_segment)) ? $this->uri->segment($uri_segment) : 0;
        if($page != 0) $page = $this->per_page * ($page-1);
        $total_rows = $this->general->get_details_by_multi_columns_pagination_array('reviews',array('business_id'=>$id))->num_rows();
        $data['items'] = $this->general->get_details_by_multi_columns_pagination_array('reviews',array('business_id'=>$id),$page,$this->per_page)->result();
    
        $business = $this->general->get_details_by_multi_columns_pagination_array('business',array('id'=>$id))->row();
        $data['business'] = $business;
        $data['paging'] = globalPagination($url, $total_rows, $this->per_page, $uri_segment);
        $data['page'] = ($this->uri->segment($uri_segment)) ? $this->uri->segment($uri_segment) : 1;
        $data['per_page'] = $this->per_page;
            
        $data['title'] = 'Reviews of '.$business->business_name;
        $data['beadcrum_title'] = $business->business_name;
        $data['beadcrum_sub_title'] = 'Reviews';
        $data['active']= 'business';
        $data['page']= 'admin/business/reviews';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    function delete_business_review($review_id,$business_id)
    {
        if($review_id)
        {
            $this->db->where('id',$review_id)->delete('reviews');
            redirect_back();
        }else{
           abort(404); 
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['active'] = 0;
            $this->general->update('users','id',$id,$data);
            redirect(base_url().'colleges');
        }else{
              abort(404);
        }
    }
}
?>