<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Bom extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Bom';
        $this->load->vars($data);
    }
    
    function batch_list()
    {

        $batch_data = $this->general->get_details_by_multi_columns('batch',array('status'=>1));
        if($batch_data->num_rows() > 0)
        {
            $i=1;
            foreach($batch_data->result() as $r)
            {
                $data['batch_data'][$i]['id']=$r->id;
                $data['batch_data'][$i]['batch_no']=$r->batch_no;
                $data['batch_data'][$i]['item_warehouse']=$r->item_warehouse;

                $item_details = $this->general->get_details_by_multi_columns('warehouse',array('id'=>$r->item_warehouse));
                if($item_details->num_rows() > 0)
                {
                  $item_warehouse = $item_details->row()->name;
                }else{
                  $item_warehouse = '';
                }
                $data['batch_data'][$i]['warehouse_name']=$item_warehouse;

                $data['batch_data'][$i]['product_id'] =$r->product_id;
                $stock_item = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$r->product_id));
                if($stock_item->num_rows() > 0)
                {
                  $stock_product_name = $stock_item->row()->product_name;
                }else{
                  $stock_product_name = '';
                }
                $data['batch_data'][$i]['name']=$stock_product_name;


                $i++;    
            }
        }
        else
        {
           $data['batch_data'] = array(); 
        }
        $data['title'] = 'BOM List';
        $data['beadcrum_title'] = 'BOM List';
        $data['beadcrum_sub_title'] = 'BOM List';
        $data['active']= 'BOM';
        $data['page']= 'admin/batch/batch_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function created_bom()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'BOM Details';
        $data['beadcrum_title'] = 'BOM';
        $data['beadcrum_sub_title'] = 'Create BOM';
        $data['active']= 'BOM';
        $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
        $data['page']= 'admin/bom/created_bom';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {        
        $this->form_validation->set_rules('bom_name','bom name','trim|required');
        $this->form_validation->set_rules('bom_product_name','bom product name','trim|required');
        $this->form_validation->set_rules('no_of_unit','batch no','trim|required');
        $this->form_validation->set_rules('rate_of_material','item name','trim|required');
        $this->form_validation->set_rules('bom_item_name','item name','trim|required');
        $this->form_validation->set_rules('quantity','item quantity','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Bom/created_bom');
        }else
        {
            //print_r($_POST);
            $data['bom_name'] = $this->input_params['bom_name'];
            $data['bom_product_name'] = $this->input_params['bom_product_name'];
            $data['no_of_unit'] = $this->input_params['no_of_unit'];
            $data['rate_of_material'] = $this->input_params['rate_of_material'];
            $data['created'] = date('Y-m-d H:i:s');
            $this->general->insert('BOM',$data);

            // $bom_details= $this->general->get_details_by_single_column('BOM','bom_name',$this->input_params['bom_name'])->result();
            $data['batch_details']= $this->general->get_details_by_multi_columns('BOM',array('status'=>1));

            // $b_data['bom_id']=$data['batch_details']->row()->id;
            // $b_data['bom_item_name'] = $this->input_params['bom_item_name'];
            // $b_data['quantity'] = $this->input_params['quantity'];
            // $b_data['created'] = date('Y-m-d H:i:s');

            $bom_id=$data['batch_details']->row()->id;
            $bom_item_name= $this->input_params['bom_item_name'];
            $quantity= $this->input_params['quantity'];
            $created= date('Y-m-d H:i:s');
            for ($i = 0; $i<=$bom_item_name; $i++)
            {
                $b_data = array(
                    'bom_id' => $bom_id,
                    'bom_item_name' => $bom_item_name,
                    'quantity' => $quantity
                    
                );
            }


            $this->general->insert('bom_items',$b_data);


                        $this->session->set_flashdata('success','BOM Details added successfully.');
                        redirect(base_url().'Bom/created_bom');
                
                        
        }
    }
    
    function edit_batch($id)
    {
        $user = $this->general->get_details_by_multi_columns('batch',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit batch';
            $data['beadcrum_title'] = 'batch';
            $data['beadcrum_sub_title'] = 'Edit batch';
            $data['active']= 'Batch';
            $data['batch_details']= $this->general->get_details_by_multi_columns('warehouse',array('status'=>1))->result();

            $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
    
            $data['page']= 'admin/batch/edit_batch';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update_batch($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('batch',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('batch_no','batch no','trim|required');
        $this->form_validation->set_rules('item_warehouse','item warehouse','trim|required');
        $this->form_validation->set_rules('batch_size','batch no','trim|required');
        $this->form_validation->set_rules('product_id','item name','trim|required');
        $this->form_validation->set_rules('description','description','trim|required');
        $this->form_validation->set_rules('created_date', 'create date', 'required');
        $this->form_validation->set_rules('expiry_date', 'create date', 'required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Batch/edit_batch/'.$id);
        }else{
            //print_r($_POST);
            $data['batch_no'] = $this->input_params['batch_no'];
            $data['item_warehouse'] = $this->input_params['item_warehouse'];
            $data['batch_size'] = $this->input_params['batch_size'];
            $data['product_id'] = $this->input_params['product_id'];
            $data['description'] = $this->input_params['description'];
            $data['created_date'] = date('Y-m-d', strtotime($this->input_params['created_date']));
            $data['expiry_date'] = date('Y-m-d', strtotime($this->input_params['expiry_date']));

              /////////validation for batch id unique/////////
            $get_batch_no = $this->general->get_details_by_single_column('batch','batch_no',$this->input_params['batch_no']);

            if($get_batch_no->num_rows() > 0)
            {
                $this->session->set_flashdata('error','Batch No  is already exist.Please enter another Batch No. ');
                redirect(base_url().'Batch/edit_batch/'.$id);
            }
            else{
            $this->general->update('batch','id',$id,$data);
            $this->session->set_flashdata('success','batch updated successfully.');
            redirect(base_url().'Batch/batch_list');
            }
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('batch','id',$id,$data);
            $this->session->set_flashdata('success','Batch  deleted successfully.');

            redirect(base_url().'Batch/batch_list');
        }
        abort(404);
    }
}
?>