<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Category extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Category';
        $this->load->vars($data);
    }
    
    function index()
    {
        $data['items'] = $this->general->get_details_by_multi_columns('categories',array('active'=>1))->result();
        $data['title'] = 'Categories';
        $data['beadcrum_title'] = 'Category';
        $data['beadcrum_sub_title'] = 'Categories';
        $data['active']= 'category';
        $data['page']= 'admin/category/index';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Category';
        $data['beadcrum_title'] = 'Category';
        $data['beadcrum_sub_title'] = 'Create Category';
        $data['active']= 'category';
        $data['page']= 'admin/category/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {
        $this->form_validation->set_rules('category_name','Category Name','trim|required|is_unique[categories.category]');
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'category/create');
        }else{
            //print_r($_POST);
            $data['category'] = $this->input_params['category_name'];
            $data['created'] = date('Y-m-d H:i:s');
            $this->general->insert('categories',$data);
            $this->session->set_flashdata('success','Category added successfully.');
            redirect(base_url().'categories');
        }
    }
    
    function edit($id)
    {
        $category = $this->general->get_details_by_multi_columns('categories',array('id'=>$id))->row();
        if($category)
        {
            $data['row']=$category;
            $data['title'] = 'Edit Category';
            $data['beadcrum_title'] = 'Category';
            $data['beadcrum_sub_title'] = 'Edit Category';
            $data['active']= 'category';
            $data['page']= 'admin/category/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $category = $this->general->get_details_by_multi_columns('categories',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $is_unique =  '';
        if($this->input_params['category_name'] != $category->category) {
            $is_unique =  '|is_unique[categories.category]';
        } 
        $this->form_validation->set_rules('category_name','Category Name','trim|required'.$is_unique);
        
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'category/edit/'.$id);
        }else{
            //print_r($_POST);
            $data['category'] = $this->input_params['category_name'];
            $this->general->update('categories','id',$id,$data);
            $this->session->set_flashdata('success','Category updated successfully.');
            redirect(base_url().'categories');
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['active'] = 0;
            $this->general->update('categories','id',$id,$data);
            redirect(base_url().'categories');
        }
        abort(404);
    }
}
?>