<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Company extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Company';
        $this->load->vars($data);
    }
    
    function index()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Company/index";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('company',array('active'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $items = $this->general->fetch_company($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $items = $this->general->get_details_by_multi_columns('company',array('active'=>1));
        if(!empty($items))
        {
            $i=1;
            foreach($items as $r)
            {
                $data['items'][$i]['id']=$r->id;
                $data['items'][$i]['name']=$r->name;
                $data['items'][$i]['date_added']=$r->date_added;
                $data['items'][$i]['date_modified']=$r->date_modified;
                $i++;    
            }
        }
        else
        {
           $data['items'] = array(); 
        }
       
        $data['title'] = 'Company List';
        $data['beadcrum_title'] = 'Company List';
        $data['beadcrum_sub_title'] = 'Company List';
        $data['active']= 'Company';
        $data['page']= 'admin/company/index';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Company';
        $data['beadcrum_title'] = 'Company';
        $data['beadcrum_sub_title'] = 'Create Company';
        $data['active']= 'Company';
        $data['page']= 'admin/company/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {
        $this->form_validation->set_rules('name','Comapny Name','trim|required');
        //$this->form_validation->set_rules('date_added','create date','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Company/create');
        }else
        {

          
                $data['name'] = $this->input_params['name'];
                $data['date_added'] = date('Y-m-d H:i:s');
                $get_camp_name = $this->general->get_details_by_single_column('company','name',$this->input_params['name']);
                if($get_camp_name->num_rows() > 0)
                {
                    $this->session->set_flashdata('error','Company name is already exist.Please enter another company name');
                    redirect(base_url().'Company/create');
    
                }else{
                $this->general->insert('company',$data);
                $this->session->set_flashdata('success','Company added successfully.');
                redirect(base_url().'Company/index');
                }
                
        }

           
        
    }
    
    function edit($id)
    {
        $comp = $this->general->get_details_by_multi_columns('company',array('id'=>$id))->row();
        if($comp)
        {
            $data['row']=$comp;
            $data['title'] = 'Edit company';
            $data['beadcrum_title'] = 'company';
            $data['beadcrum_sub_title'] = 'Edit company';
            $data['active']= 'Company';
            $data['page']= 'admin/company/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $compny = $this->general->get_details_by_multi_columns('company',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('name','Comapny Name','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Company/edit');
        }else{
            //print_r($_POST);
            $data['name'] = $this->input_params['name'];
            $data['date_modified'] =date('Y-m-d H:i:s');
            $get_camp_name = $this->general->get_details_by_single_column('company','name',$this->input_params['name']);
            if($get_camp_name->num_rows() > 0)
            {
                $this->session->set_flashdata('error','Company name is already exist.Please enter another company name');
                redirect(base_url().'Company/edit/'.$id);

            }else{
                $this->general->update('company','id',$id,$data);
                $this->session->set_flashdata('success','Company  updated successfully.');
                redirect(base_url().'Company/index');
            }
           
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['active'] = 0;
            $this->general->update('categories','id',$id,$data);
            redirect(base_url().'categories');
        }
        abort(404);
    }
}
?>