<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Customer_sample extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Customer_sample';
        $this->load->vars($data);
    }
    
    function list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Customer_sample/list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('customer_sample',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $sample_data = $this->general->fetch_customer_sample_details($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $batch_data = $this->general->get_details_by_multi_columns('batch',array('status'=>1));
        if(!empty($sample_data))
        {
            $i=1;
            foreach($sample_data as $r)
            {
                $data['sample_data'][$i]['id']=$r->id;
                $data['sample_data'][$i]['customer_name']=$r->customer_name;
                $data['sample_data'][$i]['product_name']=$r->product_name;

                $product_item = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$r->product_name));
                if($product_item->num_rows() > 0)
                {
                  $stock_product_name = $product_item->row()->product_name;
                }else{
                  $stock_product_name = '';
                }
                $data['sample_data'][$i]['name']=$stock_product_name;


                $i++;    
            }
        }
        else
        {
           $data['sample_data'] = array(); 
        }
        $data['title'] = 'Customer sample List';
        $data['beadcrum_title'] = 'Customer sample List';
        $data['beadcrum_sub_title'] = 'Customer sample List';
        $data['active']= 'Customer sample';
        $data['page']= 'admin/customer_sample/list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'customer sample';
        $data['beadcrum_title'] = 'customer sample';
        $data['beadcrum_sub_title'] = 'Create customer sample';
        $data['active']= 'Customer sample';
        $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
        $data['page']= 'admin/customer_sample/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {        
        $this->form_validation->set_rules('add_date','batch no','trim|required');
        $this->form_validation->set_rules('customer_name','item warehouse','trim|required');
        $this->form_validation->set_rules('product_name','batch no','trim|required');
        $this->form_validation->set_rules('Quantity','item name','trim|required');
        $this->form_validation->set_rules('no_of_sample_value','code no','trim|required');
        $this->form_validation->set_rules('add_PA','quantity','trim|required');
        $this->form_validation->set_rules('add_PH','no of sample value','trim|required');
        $this->form_validation->set_rules('add_solid','accepted by','trim|required');
        $this->form_validation->set_rules('value_name','expected date','trim|required');
        $this->form_validation->set_rules('add_value','Invert date','trim|required');
        $this->form_validation->set_rules('approved_by','supplier name','trim|required');
        $this->form_validation->set_rules('rejected_by','invoice no','trim|required');
        
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Customer_sample/create');
        }else
        {
            //print_r($_POST);
            $data['add_date'] = date('Y-m-d', strtotime($this->input_params['add_date']));
            $data['customer_name'] = $this->input_params['customer_name'];
            $data['product_name'] = $this->input_params['product_name'];
            $data['Quantity'] = $this->input_params['Quantity'];
            $data['no_of_sample_value'] = $this->input_params['no_of_sample_value'];
            $data['add_PA'] = $this->input_params['add_PA'];
            $data['add_PH'] = $this->input_params['add_PH'];
            $data['add_solid'] = $this->input_params['add_solid'];
            $data['value_name'] = $this->input_params['value_name'];
            $data['add_value'] = $this->input_params['add_value'];
            $data['approved_by'] = $this->input_params['approved_by'];
            $data['rejected_by'] = $this->input_params['rejected_by'];
          
                $this->general->insert('customer_sample',$data);
                $this->session->set_flashdata('success','customer details added successfully.');
                redirect(base_url().'Customer_sample/list');
    
               
            
        }
    }
    
    function edit($id)
    {
        $user = $this->general->get_details_by_multi_columns('customer_sample',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit customer';
            $data['beadcrum_title'] = 'customer';
            $data['beadcrum_sub_title'] = 'Edit customer';
            $data['active']= 'Customer sample';
            $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
            $data['page']= 'admin/customer_sample/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('customer_sample',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('add_date','batch no','trim|required');
        $this->form_validation->set_rules('customer_name','item warehouse','trim|required');
        $this->form_validation->set_rules('product_name','batch no','trim|required');
        $this->form_validation->set_rules('Quantity','item name','trim|required');
        $this->form_validation->set_rules('no_of_sample_value','code no','trim|required');
        $this->form_validation->set_rules('add_PA','quantity','trim|required');
        $this->form_validation->set_rules('add_PH','no of sample value','trim|required');
        $this->form_validation->set_rules('add_solid','accepted by','trim|required');
        $this->form_validation->set_rules('value_name','expected date','trim|required');
        $this->form_validation->set_rules('add_value','Invert date','trim|required');
        $this->form_validation->set_rules('approved_by','supplier name','trim|required');
        $this->form_validation->set_rules('rejected_by','invoice no','trim|required');
        
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Customer_sample/edit/'.$id);
        }else{
            //print_r($_POST);
            $data['add_date'] = date('Y-m-d', strtotime($this->input_params['add_date']));
            $data['customer_name'] = $this->input_params['customer_name'];
            $data['product_name'] = $this->input_params['product_name'];
            $data['Quantity'] = $this->input_params['Quantity'];
            $data['no_of_sample_value'] = $this->input_params['no_of_sample_value'];
            $data['add_PA'] = $this->input_params['add_PA'];
            $data['add_PH'] = $this->input_params['add_PH'];
            $data['add_solid'] = $this->input_params['add_solid'];
            $data['value_name'] = $this->input_params['value_name'];
            $data['add_value'] = $this->input_params['add_value'];
            $data['approved_by'] = $this->input_params['approved_by'];
            $data['rejected_by'] = $this->input_params['rejected_by'];
            $data['modified'] = date('Y-m-d H:i:s');

            $this->general->update('customer_sample','id',$id,$data);
            $this->session->set_flashdata('success','customer details updated successfully.');
            redirect(base_url().'Customer_sample/list');
            
        }
    }
    
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('customer_sample','id',$id,$data);
            $this->session->set_flashdata('success','customer details  deleted successfully.');

            redirect(base_url().'Customer_sample/list');
        }
        abort(404);
    }
    
}
?>