<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Outward extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Outward';
        $this->load->vars($data);
    }
    
    function list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Batch/batch_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('Outword',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $Outward_data = $this->general->fetch_outward_details($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $batch_data = $this->general->get_details_by_multi_columns('batch',array('status'=>1));
        if(!empty($Outward_data))
        {
            $i=1;
            foreach($Outward_data as $r)
            {
                $data['Outward_data'][$i]['id']=$r->id;
                $data['Outward_data'][$i]['customer_name']=$r->customer_name;
                $data['Outward_data'][$i]['source_of_customer']=$r->source_of_customer;
                $data['Outward_data'][$i]['outward_product_name']=$r->outward_product_name;

                $product_item = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$r->outward_product_name));
                if($product_item->num_rows() > 0)
                {
                  $stock_product_name = $product_item->row()->product_name;
                }else{
                  $stock_product_name = '';
                }
                $data['Outward_data'][$i]['name']=$stock_product_name;


                $i++;    
            }
        }
        else
        {
           $data['Outward_data'] = array(); 
        }
        $data['title'] = 'Outward List';
        $data['beadcrum_title'] = 'Outward List';
        $data['beadcrum_sub_title'] = 'Outward List';
        $data['active']= 'Outward';
        $data['page']= 'admin/outward/list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Outward';
        $data['beadcrum_title'] = 'Outward';
        $data['beadcrum_sub_title'] = 'Create Outward';
        $data['active']= 'Outward';
        $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
        $data['batch_details']= $this->general->get_details_by_multi_columns('warehouse',array('status'=>1))->result();
        $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
        $data['unit_details']= $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();

        $data['page']= 'admin/outward/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {        
        $this->form_validation->set_rules('add_outward_date','batch no','trim|required');
        $this->form_validation->set_rules('customer_name','item warehouse','trim|required');
        $this->form_validation->set_rules('outward_product_name','batch no','trim|required');
        $this->form_validation->set_rules('outward_quantity','item name','trim|required');
        $this->form_validation->set_rules('no_units_value','code no','trim|required');
        $this->form_validation->set_rules('add_outward_PA','quantity','trim|required');
        $this->form_validation->set_rules('add_outward_PH','accepted by','trim|required');
        $this->form_validation->set_rules('add_outward_solid','Invert date','trim|required');
        $this->form_validation->set_rules('outward_value_name','supplier name','trim|required');
        $this->form_validation->set_rules('outward_value','invoice no','trim|required');
        $this->form_validation->set_rules('source_of_customer','invoice date','trim|required');
        $this->form_validation->set_rules('outward_approved_by','cost name','trim|required');
        $this->form_validation->set_rules('outward_rejected_by','cost value','trim|required');
       

        //$this->form_validation->set_rules('date_added','create date','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Outward/create');
        }else
        {
            //print_r($_POST);
            $data['add_outward_date'] = $this->input_params['add_outward_date'];
            $data['customer_name'] = $this->input_params['customer_name'];
            $data['outward_product_name'] = $this->input_params['outward_product_name'];
            $data['outward_quantity'] = $this->input_params['outward_quantity'];
            $data['no_units_value'] = $this->input_params['no_units_value'];
            $data['add_outward_PA'] = $this->input_params['add_outward_PA'];
            $data['add_outward_PH'] = $this->input_params['add_outward_PH'];
            $data['add_outward_solid'] = $this->input_params['add_outward_solid'];
            $data['outward_value_name'] = $this->input_params['outward_value_name'];
            $data['outward_value'] = $this->input_params['outward_value'];
            $data['source_of_customer'] = $this->input_params['source_of_customer'];
            $data['outward_approved_by'] = $this->input_params['outward_approved_by'];
            $data['outward_rejected_by'] = $this->input_params['outward_rejected_by'];
           
                $this->general->insert('Outword',$data);
                $this->session->set_flashdata('success','Outward details added successfully.');
                redirect(base_url().'Outward/list');
    
               
            
        }
    }
    
    function edit($id)
    {
        $user = $this->general->get_details_by_multi_columns('Outword',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit Outward';
            $data['beadcrum_title'] = 'Outward';
            $data['beadcrum_sub_title'] = 'Edit Outward';
            $data['active']= 'Outward';
            $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
            $data['batch_details']= $this->general->get_details_by_multi_columns('warehouse',array('status'=>1))->result();
            $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
            $data['unit_details']= $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();

            $data['page']= 'admin/outward/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('Outword',array('id'=>$id))->row();
        //print_r($category->category);exit;
         $this->form_validation->set_rules('add_outward_date','batch no','trim|required');
        $this->form_validation->set_rules('customer_name','item warehouse','trim|required');
        $this->form_validation->set_rules('outward_product_name','batch no','trim|required');
        $this->form_validation->set_rules('outward_quantity','item name','trim|required');
        $this->form_validation->set_rules('no_units_value','code no','trim|required');
        $this->form_validation->set_rules('add_outward_PA','quantity','trim|required');
        $this->form_validation->set_rules('add_outward_PH','accepted by','trim|required');
        $this->form_validation->set_rules('add_outward_solid','Invert date','trim|required');
        $this->form_validation->set_rules('outward_value_name','supplier name','trim|required');
        $this->form_validation->set_rules('outward_value','invoice no','trim|required');
        $this->form_validation->set_rules('source_of_customer','invoice date','trim|required');
        $this->form_validation->set_rules('outward_approved_by','cost name','trim|required');
        $this->form_validation->set_rules('outward_rejected_by','cost value','trim|required');
       
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Outward/edit/'.$id);
        }else{
            //print_r($_POST);
            $data['add_outward_date'] = $this->input_params['add_outward_date'];
            $data['customer_name'] = $this->input_params['customer_name'];
            $data['outward_product_name'] = $this->input_params['outward_product_name'];
            $data['outward_quantity'] = $this->input_params['outward_quantity'];
            $data['no_units_value'] = $this->input_params['no_units_value'];
            $data['add_outward_PA'] = $this->input_params['add_outward_PA'];
            $data['add_outward_PH'] = $this->input_params['add_outward_PH'];
            $data['add_outward_solid'] = $this->input_params['add_outward_solid'];
            $data['outward_value_name'] = $this->input_params['outward_value_name'];
            $data['outward_value'] = $this->input_params['outward_value'];
            $data['source_of_customer'] = $this->input_params['source_of_customer'];
            $data['outward_approved_by'] = $this->input_params['outward_approved_by'];
            $data['outward_rejected_by'] = $this->input_params['outward_rejected_by'];
           
            $data['modified_date'] = date('Y-m-d H:i:s');

            $this->general->update('Outword','id',$id,$data);
            $this->session->set_flashdata('success','Outward details updated successfully.');
            redirect(base_url().'Outward/list');
            
        }
    }
    
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('Outword','id',$id,$data);
            $this->session->set_flashdata('success','Outward details  deleted successfully.');

            redirect(base_url().'Outward/list');
        }
        abort(404);
    }
    
}
?>