<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Production extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Production';
        $this->load->vars($data);
    }
    
    function production_list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Production/production_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('production',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $production_data = $this->general->fetch_production_details($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $batch_data = $this->general->get_details_by_multi_columns('batch',array('status'=>1));
        if(!empty($production_data))
        {
            $i=1;
            foreach($production_data as $r)
            {
                $data['production_data'][$i]['id']=$r->id;
                $data['production_data'][$i]['add_production_company_name']=$r->add_production_company_name;
                $data['production_data'][$i]['production_code_no']=$r->production_code_no;
                $data['production_data'][$i]['production_batch_no']=$r->production_batch_no;

                $cmpny_details = $this->general->get_details_by_multi_columns('company',array('id'=>$r->add_production_company_name));
                if($cmpny_details->num_rows() > 0)
                {
                  $campany_name = $cmpny_details->row()->name;
                }else{
                  $campany_name = '';
                }
                $data['production_data'][$i]['camp_name']=$campany_name;

                $data['production_data'][$i]['production_product_name']=$r->production_product_name;

                $product_item = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$r->production_product_name));
                if($product_item->num_rows() > 0)
                {
                  $stock_product_name = $product_item->row()->product_name;
                }else{
                  $stock_product_name = '';
                }
                $data['production_data'][$i]['name']=$stock_product_name;


                $i++;    
            }
        }
        else
        {
           $data['production_data'] = array(); 
        }
        $data['title'] = 'Production List';
        $data['beadcrum_title'] = 'Production List';
        $data['beadcrum_sub_title'] = 'Production List';
        $data['active']= 'Production';
        $data['page']= 'admin/production/production_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create_production()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Production';
        $data['beadcrum_title'] = 'Production';
        $data['beadcrum_sub_title'] = 'Create Production';
        $data['active']= 'Production';
        $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
        $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
        $data['page']= 'admin/production/create_production';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {        
        $this->form_validation->set_rules('add_production_company_name','batch no','trim|required');
        $this->form_validation->set_rules('add_production_date','item warehouse','trim|required');
        $this->form_validation->set_rules('testing_report_no','batch no','trim|required');
        $this->form_validation->set_rules('production_product_name','item name','trim|required');
        $this->form_validation->set_rules('production_code_no','code no','trim|required');
        $this->form_validation->set_rules('production_batch_no','quantity','trim|required');
        $this->form_validation->set_rules('production_quantity','no of sample value','trim|required');
        $this->form_validation->set_rules('no_of_production_sample_value','accepted by','trim|required');
        $this->form_validation->set_rules('prepared_by','expected date','trim|required');
        $this->form_validation->set_rules('approved_by','Invert date','trim|required');
        $this->form_validation->set_rules('production_value_name','supplier name','trim|required');
        $this->form_validation->set_rules('production_value','invoice no','trim|required');
        $this->form_validation->set_rules('add_production_PA','invoice date','trim|required');
        $this->form_validation->set_rules('add_production_PH','cost value','trim|required');
        $this->form_validation->set_rules('add_production_solid','Approved Quality Control','trim|required');
        $this->form_validation->set_rules('add_production_solubility','qc value_name','trim|required');
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Production/create');
        }else
        {
            //print_r($_POST);
            $data['add_production_company_name'] = $this->input_params['add_production_company_name'];
            $data['add_production_date'] = date('Y-m-d', strtotime($this->input_params['add_production_date']));
            $data['testing_report_no'] = $this->input_params['testing_report_no'];
            $data['production_product_name'] = $this->input_params['production_product_name'];
            $data['production_code_no'] = $this->input_params['production_code_no'];
            $data['production_batch_no'] = $this->input_params['production_batch_no'];
            $data['production_quantity'] = $this->input_params['production_quantity'];
            $data['no_of_production_sample_value'] = $this->input_params['no_of_production_sample_value'];
            $data['prepared_by'] = $this->input_params['prepared_by'];
            $data['approved_by'] = $this->input_params['approved_by'];
            $data['production_value_name'] = $this->input_params['production_value_name'];
            $data['production_value'] = $this->input_params['production_value'];
            $data['add_production_PA'] = $this->input_params['add_production_PA'];
            $data['add_production_PH'] = $this->input_params['add_production_PH'];
            $data['add_production_solid'] = $this->input_params['add_production_solid'];
            $data['add_production_solubility'] = $this->input_params['add_production_solubility'];
          
                $this->general->insert('production',$data);
                $this->session->set_flashdata('success','production details added successfully.');
                redirect(base_url().'Production/production_list');
    
               
            
        }
    }
    
    function edit_production($id)
    {
        $user = $this->general->get_details_by_multi_columns('production',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit Production';
            $data['beadcrum_title'] = 'Production';
            $data['beadcrum_sub_title'] = 'Edit Production';
            $data['active']= 'Production';
            $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
            $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
            $data['page']= 'admin/production/edit_production';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('production',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('add_production_company_name','batch no','trim|required');
        $this->form_validation->set_rules('add_production_date','item warehouse','trim|required');
        $this->form_validation->set_rules('testing_report_no','batch no','trim|required');
        $this->form_validation->set_rules('production_product_name','item name','trim|required');
        $this->form_validation->set_rules('production_code_no','code no','trim|required');
        $this->form_validation->set_rules('production_batch_no','quantity','trim|required');
        $this->form_validation->set_rules('production_quantity','no of sample value','trim|required');
        $this->form_validation->set_rules('no_of_production_sample_value','accepted by','trim|required');
        $this->form_validation->set_rules('prepared_by','expected date','trim|required');
        $this->form_validation->set_rules('approved_by','Invert date','trim|required');
        $this->form_validation->set_rules('production_value_name','supplier name','trim|required');
        $this->form_validation->set_rules('production_value','invoice no','trim|required');
        $this->form_validation->set_rules('add_production_PA','invoice date','trim|required');
        $this->form_validation->set_rules('add_production_PH','cost value','trim|required');
        $this->form_validation->set_rules('add_production_solid','Approved Quality Control','trim|required');
        $this->form_validation->set_rules('add_production_solubility','qc value_name','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Production/edit_production/'.$id);
        }else{
            //print_r($_POST);
            $data['add_production_company_name'] = $this->input_params['add_production_company_name'];
            $data['add_production_date'] = date('Y-m-d', strtotime($this->input_params['add_production_date']));
            $data['testing_report_no'] = $this->input_params['testing_report_no'];
            $data['production_product_name'] = $this->input_params['production_product_name'];
            $data['production_code_no'] = $this->input_params['production_code_no'];
            $data['production_batch_no'] = $this->input_params['production_batch_no'];
            $data['production_quantity'] = $this->input_params['production_quantity'];
            $data['no_of_production_sample_value'] = $this->input_params['no_of_production_sample_value'];
            $data['prepared_by'] = $this->input_params['prepared_by'];
            $data['approved_by'] = $this->input_params['approved_by'];
            $data['production_value_name'] = $this->input_params['production_value_name'];
            $data['production_value'] = $this->input_params['production_value'];
            $data['add_production_PA'] = $this->input_params['add_production_PA'];
            $data['add_production_PH'] = $this->input_params['add_production_PH'];
            $data['add_production_solid'] = $this->input_params['add_production_solid'];
            $data['add_production_solubility'] = $this->input_params['add_production_solubility'];
            $data['modified_date'] = date('Y-m-d H:i:s');

            $this->general->update('production','id',$id,$data);
            $this->session->set_flashdata('success','production details updated successfully.');
            redirect(base_url().'Production/production_list');
            
        }
    }
    
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('production','id',$id,$data);
            $this->session->set_flashdata('success','production details  deleted successfully.');

            redirect(base_url().'Production/production_list');
        }
        abort(404);
    }
    
}
?>