<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class QCMaster extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | QCMaster';
        $this->load->vars($data);
    }
    
    function list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Batch/batch_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('QCMaster',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $QCMaster_data = $this->general->fetch_QCmaster_details($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $batch_data = $this->general->get_details_by_multi_columns('batch',array('status'=>1));
        if(!empty($QCMaster_data))
        {
            $i=1;
            foreach($QCMaster_data as $r)
            {
                $data['QCMaster_data'][$i]['id']=$r->id;
                $data['QCMaster_data'][$i]['add_company_name']=$r->add_company_name;
                $data['QCMaster_data'][$i]['supplier_name']=$r->supplier_name;
                $data['QCMaster_data'][$i]['qc_HSN_code']=$r->qc_HSN_code;

                $cmpny_details = $this->general->get_details_by_multi_columns('company',array('id'=>$r->add_company_name));
                if($cmpny_details->num_rows() > 0)
                {
                  $campany_name = $cmpny_details->row()->name;
                }else{
                  $campany_name = '';
                }
                $data['QCMaster_data'][$i]['camp_name']=$campany_name;

                $data['QCMaster_data'][$i]['qc_product_name']=$r->qc_product_name;

                $product_item = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$r->qc_product_name));
                if($product_item->num_rows() > 0)
                {
                  $stock_product_name = $product_item->row()->product_name;
                }else{
                  $stock_product_name = '';
                }
                $data['QCMaster_data'][$i]['name']=$stock_product_name;


                $i++;    
            }
        }
        else
        {
           $data['QCMaster_data'] = array(); 
        }
        $data['title'] = 'QCMaster List';
        $data['beadcrum_title'] = 'QCMaster List';
        $data['beadcrum_sub_title'] = 'QCMaster List';
        $data['active']= 'QCMaster';
        $data['page']= 'admin/Qcmaster/list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'QC Master';
        $data['beadcrum_title'] = 'QC Master';
        $data['beadcrum_sub_title'] = 'Create QC Master';
        $data['active']= 'QC Master';
        $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
        $data['batch_details']= $this->general->get_details_by_multi_columns('warehouse',array('status'=>1))->result();
        $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
        $data['unit_details']= $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();

        $data['page']= 'admin/Qcmaster/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {        
        $this->form_validation->set_rules('add_company_name','batch no','trim|required');
        $this->form_validation->set_rules('add_date','item warehouse','trim|required');
        $this->form_validation->set_rules('order_by','batch no','trim|required');
        $this->form_validation->set_rules('qc_product_name','item name','trim|required');
        $this->form_validation->set_rules('code_no','code no','trim|required');
        $this->form_validation->set_rules('quantity','quantity','trim|required');
        $this->form_validation->set_rules('no_of_sample_value','no of sample value','trim|required');
        $this->form_validation->set_rules('accepted_by','accepted by','trim|required');
        $this->form_validation->set_rules('expected_date','expected date','trim|required');
        $this->form_validation->set_rules('Invert_date','Invert date','trim|required');
        $this->form_validation->set_rules('supplier_name','supplier name','trim|required');
        $this->form_validation->set_rules('invoice_no','invoice no','trim|required');
        $this->form_validation->set_rules('invoice_date','invoice date','trim|required');
        $this->form_validation->set_rules('cost_name','cost name','trim|required');
        $this->form_validation->set_rules('cost_value','cost value','trim|required');
        $this->form_validation->set_rules('qc_HSN_code','qc HSN_code','trim|required');
        $this->form_validation->set_rules('Approved_Quality_Control','Approved Quality Control','trim|required');
        $this->form_validation->set_rules('qc_value_name','qc value_name','trim|required');
        $this->form_validation->set_rules('qc_value','qc value','trim|required');
        $this->form_validation->set_rules('add_PA','add PA','trim|required');
        $this->form_validation->set_rules('PA_exteption_area','PA exteption_area','trim|required');
        $this->form_validation->set_rules('add_PH','add PH','trim|required');
        $this->form_validation->set_rules('PH_exteption_area','PH exteption_area','trim|required');
        $this->form_validation->set_rules('add_solid', 'add solid', 'required');
        $this->form_validation->set_rules('add_solubility', 'add solubility', 'required');

        //$this->form_validation->set_rules('date_added','create date','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'QCMaster/create');
        }else
        {
            //print_r($_POST);
            $data['add_company_name'] = $this->input_params['add_company_name'];
            $data['add_date'] = $this->input_params['add_date'];
            $data['order_by'] = $this->input_params['order_by'];
            $data['qc_product_name'] = $this->input_params['qc_product_name'];
            $data['code_no'] = $this->input_params['code_no'];
            $data['quantity'] = $this->input_params['quantity'];
            $data['no_of_sample_value'] = $this->input_params['no_of_sample_value'];
            $data['accepted_by'] = $this->input_params['accepted_by'];
            $data['expected_date'] = date('Y-m-d', strtotime($this->input_params['expected_date']));
            $data['Invert_date'] = date('Y-m-d', strtotime($this->input_params['Invert_date']));
            $data['supplier_name'] = $this->input_params['supplier_name'];
            $data['invoice_no'] = $this->input_params['invoice_no'];
            $data['invoice_date'] = date('Y-m-d', strtotime($this->input_params['invoice_date']));
            $data['cost_name'] = $this->input_params['cost_name'];
            $data['cost_value'] = $this->input_params['cost_value'];
            $data['qc_HSN_code'] = $this->input_params['qc_HSN_code'];
            $data['Approved_Quality_Control'] = $this->input_params['Approved_Quality_Control'];
            $data['qc_value_name'] = $this->input_params['qc_value_name'];
            $data['qc_value'] = $this->input_params['qc_value'];
            $data['add_PA'] = $this->input_params['add_PA'];
            $data['PA_exteption_area'] = $this->input_params['PA_exteption_area'];
            $data['add_PH'] = $this->input_params['add_PH'];
            $data['PH_exteption_area'] = $this->input_params['PH_exteption_area'];
            $data['add_solid'] = $this->input_params['add_solid'];
            $data['add_solubility'] = $this->input_params['add_solubility'];
           
                $this->general->insert('QCMaster',$data);
                $this->session->set_flashdata('success','QCMaster details added successfully.');
                redirect(base_url().'QCMaster/list');
    
               
            
        }
    }
    
    function edit($id)
    {
        $user = $this->general->get_details_by_multi_columns('QCMaster',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit QCMaster';
            $data['beadcrum_title'] = 'QCMaster';
            $data['beadcrum_sub_title'] = 'Edit QCMaster';
            $data['active']= 'QCMaster';
            $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
            $data['batch_details']= $this->general->get_details_by_multi_columns('warehouse',array('status'=>1))->result();
            $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
            $data['unit_details']= $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();

            $data['page']= 'admin/Qcmaster/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('QCMaster',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('add_company_name','batch no','trim|required');
        $this->form_validation->set_rules('add_date','item warehouse','trim|required');
        $this->form_validation->set_rules('order_by','batch no','trim|required');
        $this->form_validation->set_rules('qc_product_name','item name','trim|required');
        $this->form_validation->set_rules('code_no','code no','trim|required');
        $this->form_validation->set_rules('quantity','quantity','trim|required');
        $this->form_validation->set_rules('no_of_sample_value','no of sample value','trim|required');
        $this->form_validation->set_rules('accepted_by','accepted by','trim|required');
        $this->form_validation->set_rules('expected_date','expected date','trim|required');
        $this->form_validation->set_rules('Invert_date','Invert date','trim|required');
        $this->form_validation->set_rules('supplier_name','supplier name','trim|required');
        $this->form_validation->set_rules('invoice_no','invoice no','trim|required');
        $this->form_validation->set_rules('invoice_date','invoice date','trim|required');
        $this->form_validation->set_rules('cost_name','cost name','trim|required');
        $this->form_validation->set_rules('cost_value','cost value','trim|required');
        $this->form_validation->set_rules('qc_HSN_code','qc HSN_code','trim|required');
        $this->form_validation->set_rules('Approved_Quality_Control','Approved Quality Control','trim|required');
        $this->form_validation->set_rules('qc_value_name','qc value_name','trim|required');
        $this->form_validation->set_rules('qc_value','qc value','trim|required');
        $this->form_validation->set_rules('add_PA','add PA','trim|required');
        $this->form_validation->set_rules('PA_exteption_area','PA exteption_area','trim|required');
        $this->form_validation->set_rules('add_PH','add PH','trim|required');
        $this->form_validation->set_rules('PH_exteption_area','PH exteption_area','trim|required');
        $this->form_validation->set_rules('add_solid', 'add solid', 'required');
        $this->form_validation->set_rules('add_solubility', 'add solubility', 'required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'QCMaster/edit/'.$id);
        }else{
            //print_r($_POST);
            $data['add_company_name'] = $this->input_params['add_company_name'];
            $data['add_date'] = $this->input_params['add_date'];
            $data['order_by'] = $this->input_params['order_by'];
            $data['qc_product_name'] = $this->input_params['qc_product_name'];
            $data['code_no'] = $this->input_params['code_no'];
            $data['quantity'] = $this->input_params['quantity'];
            $data['no_of_sample_value'] = $this->input_params['no_of_sample_value'];
            $data['accepted_by'] = $this->input_params['accepted_by'];
            $data['expected_date'] = date('Y-m-d', strtotime($this->input_params['expected_date']));
            $data['Invert_date'] = date('Y-m-d', strtotime($this->input_params['Invert_date']));
            $data['supplier_name'] = $this->input_params['supplier_name'];
            $data['invoice_no'] = $this->input_params['invoice_no'];
            $data['invoice_date'] = date('Y-m-d', strtotime($this->input_params['invoice_date']));
            $data['cost_name'] = $this->input_params['cost_name'];
            $data['cost_value'] = $this->input_params['cost_value'];
            $data['qc_HSN_code'] = $this->input_params['qc_HSN_code'];
            $data['Approved_Quality_Control'] = $this->input_params['Approved_Quality_Control'];
            $data['qc_value_name'] = $this->input_params['qc_value_name'];
            $data['qc_value'] = $this->input_params['qc_value'];
            $data['add_PA'] = $this->input_params['add_PA'];
            $data['PA_exteption_area'] = $this->input_params['PA_exteption_area'];
            $data['add_PH'] = $this->input_params['add_PH'];
            $data['PH_exteption_area'] = $this->input_params['PH_exteption_area'];
            $data['add_solid'] = $this->input_params['add_solid'];
            $data['add_solubility'] = $this->input_params['add_solubility'];
            $data['modified_date'] = date('Y-m-d H:i:s');

            $this->general->update('QCMaster','id',$id,$data);
            $this->session->set_flashdata('success','QCMaster details updated successfully.');
            redirect(base_url().'QCMaster/list');
            
        }
    }
    
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('QCMaster','id',$id,$data);
            $this->session->set_flashdata('success','QCMaster details  deleted successfully.');

            redirect(base_url().'QCMaster/list');
        }
        abort(404);
    }
    
}
?>