<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Sales extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Sales';
        $this->load->vars($data);
    }
    
    function sale_list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Sales/sale_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('sales',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $Sales_data = $this->general->fetch_sales_details($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $batch_data = $this->general->get_details_by_multi_columns('batch',array('status'=>1));
        if(!empty($Sales_data))
        {
            $i=1;
            foreach($Sales_data as $r)
            {
                $data['Sales_data'][$i]['id']=$r->id;
                $data['Sales_data'][$i]['add_company_name']=$r->add_company_name;
                $data['Sales_data'][$i]['sale_HSN_code']=$r->sale_HSN_code;
                $cmpny_details = $this->general->get_details_by_multi_columns('company',array('id'=>$r->add_company_name));
                if($cmpny_details->num_rows() > 0)
                {
                  $campany_name = $cmpny_details->row()->name;
                }else{
                  $campany_name = '';
                }
                $data['Sales_data'][$i]['camp_name']=$campany_name;

                $data['Sales_data'][$i]['sale_product_name']=$r->sale_product_name;

                $product_item = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$r->sale_product_name));
                if($product_item->num_rows() > 0)
                {
                  $stock_product_name = $product_item->row()->product_name;
                }else{
                  $stock_product_name = '';
                }
                $data['Sales_data'][$i]['name']=$stock_product_name;


                $i++;    
            }
        }
        else
        {
           $data['Sales_data'] = array(); 
        }
        $data['title'] = 'Sales List';
        $data['beadcrum_title'] = 'Sales List';
        $data['beadcrum_sub_title'] = 'Sales List';
        $data['active']= 'Sales';
        $data['page']= 'admin/sales/sale_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create_sale()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'sales';
        $data['beadcrum_title'] = 'sales';
        $data['beadcrum_sub_title'] = 'Create sales';
        $data['active']= 'sales';
        $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
        $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
        $data['unit_details']= $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();

        $data['page']= 'admin/sales/create_sale';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {        
        $this->form_validation->set_rules('add_company_name','batch no','trim|required');
        $this->form_validation->set_rules('add_order_date','item warehouse','trim|required');
        $this->form_validation->set_rules('testing_report_no','batch no','trim|required');
        $this->form_validation->set_rules('customer_name','item name','trim|required');
        $this->form_validation->set_rules('order_by','code no','trim|required');
        $this->form_validation->set_rules('sale_product_name','quantity','trim|required');
        $this->form_validation->set_rules('code_no','no of sample value','trim|required');
        $this->form_validation->set_rules('batch_no','accepted by','trim|required');
        $this->form_validation->set_rules('quantity','expected date','trim|required');
        $this->form_validation->set_rules('sales_unit','Invert date','trim|required');
        $this->form_validation->set_rules('prepared_by','supplier name','trim|required');
        $this->form_validation->set_rules('approved_by','invoice no','trim|required');
        $this->form_validation->set_rules('sale_cost_name','invoice date','trim|required');
        $this->form_validation->set_rules('sale_cost_value','cost name','trim|required');
        $this->form_validation->set_rules('sale_HSN_code','cost value','trim|required');
        $this->form_validation->set_rules('sale_value_name','qc HSN_code','trim|required');
        $this->form_validation->set_rules('sale_value','Approved Quality Control','trim|required');
        $this->form_validation->set_rules('add_sale_PA','qc value_name','trim|required');
        $this->form_validation->set_rules('add_sale_PH','qc value','trim|required');
        $this->form_validation->set_rules('add_solid','add PA','trim|required');
        $this->form_validation->set_rules('add_solubility','PA exteption_area','trim|required');
        $this->form_validation->set_rules('add_bill_no','add PH','trim|required');
        $this->form_validation->set_rules('add_dispatch_date','PH exteption_area','trim|required');
   

        //$this->form_validation->set_rules('date_added','create date','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Sales/create');
        }else
        {
            //print_r($_POST);
            $data['add_company_name'] = $this->input_params['add_company_name'];
            $data['add_order_date'] = date('Y-m-d', strtotime($this->input_params['add_order_date']));
            $data['testing_report_no'] = $this->input_params['testing_report_no'];
            $data['customer_name'] = $this->input_params['customer_name'];
            $data['order_by'] = $this->input_params['order_by'];
            $data['quantity'] = $this->input_params['quantity'];
            $data['sale_product_name'] = $this->input_params['sale_product_name'];
            $data['code_no'] = $this->input_params['code_no'];
            $data['batch_no'] = $this->input_params['batch_no'];
            $data['quantity'] = $this->input_params['quantity'];
            $data['sales_unit'] = $this->input_params['sales_unit'];
            $data['prepared_by'] = $this->input_params['prepared_by'];
            $data['approved_by'] = $this->input_params['approved_by'];
            $data['sale_cost_name'] = $this->input_params['sale_cost_name'];
            $data['sale_cost_value'] = $this->input_params['sale_cost_value'];
            $data['sale_HSN_code'] = $this->input_params['sale_HSN_code'];
            $data['sale_value_name'] = $this->input_params['sale_value_name'];
            $data['sale_value'] = $this->input_params['sale_value'];
            $data['add_sale_PA'] = $this->input_params['add_sale_PA'];
            $data['add_sale_PH'] = $this->input_params['add_sale_PH'];
            $data['add_solid'] = $this->input_params['add_solid'];
            $data['add_solubility'] = $this->input_params['add_solubility'];
            $data['add_bill_no'] = $this->input_params['add_bill_no'];
            $data['add_dispatch_date'] = date('Y-m-d', strtotime($this->input_params['add_dispatch_date']));
           
                $this->general->insert('sales',$data);
                $this->session->set_flashdata('success','sales details added successfully.');
                redirect(base_url().'Sales/create_sale');
    
               
            
        }
    }
    
    function edit_sale($id)
    {
        $user = $this->general->get_details_by_multi_columns('sales',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit sales';
            $data['beadcrum_title'] = 'sales';
            $data['beadcrum_sub_title'] = 'Edit sales';
            $data['active']= 'sales';
            $data['company_details']= $this->general->get_details_by_multi_columns('company',array('active'=>1))->result();
            $data['items_details']= $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->result();
            $data['unit_details']= $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();
            $data['page']= 'admin/sales/edit_sale';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('sales',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('add_company_name','batch no','trim|required');
        $this->form_validation->set_rules('add_order_date','item warehouse','trim|required');
        $this->form_validation->set_rules('testing_report_no','batch no','trim|required');
        $this->form_validation->set_rules('customer_name','item name','trim|required');
        $this->form_validation->set_rules('order_by','code no','trim|required');
        $this->form_validation->set_rules('sale_product_name','quantity','trim|required');
        $this->form_validation->set_rules('code_no','no of sample value','trim|required');
        $this->form_validation->set_rules('batch_no','accepted by','trim|required');
        $this->form_validation->set_rules('quantity','expected date','trim|required');
        $this->form_validation->set_rules('sales_unit','Invert date','trim|required');
        $this->form_validation->set_rules('prepared_by','supplier name','trim|required');
        $this->form_validation->set_rules('approved_by','invoice no','trim|required');
        $this->form_validation->set_rules('sale_cost_name','invoice date','trim|required');
        $this->form_validation->set_rules('sale_cost_value','cost name','trim|required');
        $this->form_validation->set_rules('sale_HSN_code','cost value','trim|required');
        $this->form_validation->set_rules('sale_value_name','qc HSN_code','trim|required');
        $this->form_validation->set_rules('sale_value','Approved Quality Control','trim|required');
        $this->form_validation->set_rules('add_sale_PA','qc value_name','trim|required');
        $this->form_validation->set_rules('add_sale_PH','qc value','trim|required');
        $this->form_validation->set_rules('add_solid','add PA','trim|required');
        $this->form_validation->set_rules('add_solubility','PA exteption_area','trim|required');
        $this->form_validation->set_rules('add_bill_no','add PH','trim|required');
        $this->form_validation->set_rules('add_dispatch_date','PH exteption_area','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Sales/edit_sale/'.$id);
        }else{
            //print_r($_POST);
            $data['add_company_name'] = $this->input_params['add_company_name'];
            $data['add_order_date'] = date('Y-m-d', strtotime($this->input_params['add_order_date']));
            $data['testing_report_no'] = $this->input_params['testing_report_no'];
            $data['customer_name'] = $this->input_params['customer_name'];
            $data['order_by'] = $this->input_params['order_by'];
            $data['quantity'] = $this->input_params['quantity'];
            $data['sale_product_name'] = $this->input_params['sale_product_name'];
            $data['code_no'] = $this->input_params['code_no'];
            $data['batch_no'] = $this->input_params['batch_no'];
            $data['quantity'] = $this->input_params['quantity'];
            $data['sales_unit'] = $this->input_params['sales_unit'];
            $data['prepared_by'] = $this->input_params['prepared_by'];
            $data['approved_by'] = $this->input_params['approved_by'];
            $data['sale_cost_name'] = $this->input_params['sale_cost_name'];
            $data['sale_cost_value'] = $this->input_params['sale_cost_value'];
            $data['sale_HSN_code'] = $this->input_params['sale_HSN_code'];
            $data['sale_value_name'] = $this->input_params['sale_value_name'];
            $data['sale_value'] = $this->input_params['sale_value'];
            $data['add_sale_PA'] = $this->input_params['add_sale_PA'];
            $data['add_sale_PH'] = $this->input_params['add_sale_PH'];
            $data['add_solid'] = $this->input_params['add_solid'];
            $data['add_solubility'] = $this->input_params['add_solubility'];
            $data['add_bill_no'] = $this->input_params['add_bill_no'];
            $data['add_dispatch_date'] = date('Y-m-d', strtotime($this->input_params['add_dispatch_date']));

            $this->general->update('sales','id',$id,$data);
            $this->session->set_flashdata('success','sales details updated successfully.');
            redirect(base_url().'Sales/sale_list');
            
        }
    }
    
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('sales','id',$id,$data);
            $this->session->set_flashdata('success','sales details  deleted successfully.');

            redirect(base_url().'Sales/sale_list');
        }
        abort(404);
    }
    
}
?>