<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Stock extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Stock';
        $this->load->vars($data);
    }
    
    function stock_list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Stock/stock_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('stoke_items',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $stock_list = $this->general->fetch_stoke_items($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $stock_list = $this->general->get_details_by_multi_columns('stoke_items',array('status'=>1));
        if(!empty($stock_list))
        {
            $i=1;
            foreach($stock_list as $r)
            {
                $data['stock_list'][$i]['id']=$r->id;
                $data['stock_list'][$i]['unit_name']=$r->unit_name;
                $data['stock_list'][$i]['code_no']=$r->code_no;
                $data['stock_list'][$i]['product_name']=$r->product_name;
                $data['stock_list'][$i]['HSN_code']=$r->HSN_code;
                $data['stock_list'][$i]['rate']=$r->rate;
                $data['stock_list'][$i]['unit_value']=$r->unit_value;
                $data['stock_list'][$i]['date_added']=$r->date_added;
                $data['stock_list'][$i]['date_modified']=$r->date_modified;
                $data['stock_list'][$i]['status']=$r->status;
                $i++;    
            }
        }
        else
        {
           $data['stock_list'] = array(); 
        }
        $data['title'] = 'Stock Items';
        $data['beadcrum_title'] = 'Stock List';
        $data['beadcrum_sub_title'] = 'Stock List';
        $data['active']= 'Stock item';
        $data['page']= 'admin/Stoke/stock_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create_stock()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Stock';
        $data['beadcrum_title'] = 'Stock';
        $data['beadcrum_sub_title'] = 'Create Stock';
        $data['active']= 'Stock item';
        $data['unit_list'] = $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();

        $data['page']= 'admin/Stoke/create_stock';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {
        
        $this->form_validation->set_rules('unit_name','stock unit name','trim|required');
        $this->form_validation->set_rules('code_no','stock code no','trim|required');
        $this->form_validation->set_rules('product_name','stock product Name','trim|required');
        $this->form_validation->set_rules('HSN_code','stock HSN code','trim|required');
        $this->form_validation->set_rules('rate','stock rate','trim|required');
        $this->form_validation->set_rules('unit_value','stock unit value','trim|required');

        //$this->form_validation->set_rules('date_added','create date','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Stock/create_stock');
        }
        
        else{
            //print_r($_POST);
            $data['unit_name'] = $this->input_params['unit_name'];
            $data['code_no'] = $this->input_params['code_no'];
            $data['product_name'] = $this->input_params['product_name'];
            $data['HSN_code'] = $this->input_params['HSN_code'];
            $data['rate'] = $this->input_params['rate'];
            $data['unit_value'] = $this->input_params['unit_value'];
            $data['date_added'] = date('Y-m-d H:i:s');
            $get_product_name = $this->general->get_details_by_single_column('stoke_items','product_name',$this->input_params['product_name']);
            if($get_product_name->num_rows() > 0)
            {
                $this->session->set_flashdata('error','product name is already exist.Please enter another product name.');
                redirect(base_url().'Stock/create_stock');
            }
            else{
                $this->general->insert('stoke_items',$data);
                $this->session->set_flashdata('success','Stock items added successfully.');
                redirect(base_url().'Stock/stock_list');
            }
              
        }
    }
    
    function edit_stock($id)
    {
        $user = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit Stock';
            $data['beadcrum_title'] = 'Stock';
            $data['beadcrum_sub_title'] = 'Edit Stock';
            $data['active']= 'Stock item';
            $unit_list = $this->general->get_details_by_multi_columns('unit',array('status'=>1))->result();
            $data['unit_list']=$unit_list;
            $data['page']= 'admin/Stoke/edit_stock';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update_stock($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('stoke_items',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('unit_name','stock unit name','trim|required');
        $this->form_validation->set_rules('code_no','stock code no','trim|required');
        $this->form_validation->set_rules('product_name','stock product Name','trim|required');
        $this->form_validation->set_rules('HSN_code','stock HSN code','trim|required');
        $this->form_validation->set_rules('rate','stock rate','trim|required');
        $this->form_validation->set_rules('unit_value','stock unit value','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Stock/edit_stock/'.$id);
        }else{
            //print_r($_POST);
            $data['unit_name'] = $this->input_params['unit_name'];
            $data['code_no'] = $this->input_params['code_no'];
            $data['product_name'] = $this->input_params['product_name'];
            $data['HSN_code'] = $this->input_params['HSN_code'];
            $data['rate'] = $this->input_params['rate'];
            $data['unit_value'] = $this->input_params['unit_value'];
            $data['date_modified'] = date('Y-m-d H:i:s');
            $get_product_name = $this->general->get_details_by_single_column('stoke_items','product_name',$this->input_params['product_name']);
            if($get_product_name->num_rows() > 0)
            {
                $this->session->set_flashdata('error','product name is already exist.Please enter another product name.');
                redirect(base_url().'Stock/edit_stock/'.$id);
            }else{
                $this->general->update('stoke_items','id',$id,$data);
                $this->session->set_flashdata('success','Stock  updated successfully.');
                redirect(base_url().'Stock/stock_list');
       
            }
                      
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('stoke_items','id',$id,$data);
            $this->session->set_flashdata('success','Stock items  deleted successfully.');
            redirect(base_url().'Stock/stock_list');
        }
        abort(404);
    }
}
?>