<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Suppliers  extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Suppliers';
        $this->load->vars($data);
    }
    
    function list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Suppliers/list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('suppliers',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $user_data = $this->general->fetch_suppliers($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();
        // $user_data = $this->general->get_details_by_multi_columns('suppliers',array('status'=>1));
        if(!empty($user_data))
        {
            $i=1;
            foreach($user_data as $r)
            {
                $data['user_data'][$i]['id']=$r->id;
                $data['user_data'][$i]['first_name']=$r->first_name;
                $data['user_data'][$i]['last_name']=$r->last_name;
                $data['user_data'][$i]['email']=$r->email;
                $data['user_data'][$i]['mobile_no']=$r->mobile_no;
                $data['user_data'][$i]['gst_no']=$r->gst_no;
                $data['user_data'][$i]['created']=$r->created;
                $data['user_data'][$i]['modified']=$r->modified;
                $data['user_data'][$i]['status']=$r->status;

                $i++;    
            }
        }
        else
        {
           $data['user_data'] = array(); 
        }
        $data['title'] = 'Suppliers List';
        $data['beadcrum_title'] = 'Suppliers List';
        $data['beadcrum_sub_title'] = 'Suppliers List';
        $data['active']= 'Suppliers';
        $data['page']= 'admin/suppliers/list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Suppliers';
        $data['beadcrum_title'] = 'Suppliers';
        $data['beadcrum_sub_title'] = 'Create Suppliers';
        $data['active']= 'Suppliers';
        $data['page']= 'admin/suppliers/create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {
        $this->form_validation->set_rules('first_name','user Name','trim|required');
        $this->form_validation->set_rules('last_name','user Name','trim|required');
        $this->form_validation->set_rules('email','user email','trim|required');
        $this->form_validation->set_rules('mobile_no','user mobile','trim|required');
        $this->form_validation->set_rules('gst_no', 'gst_no', 'required');
       

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Suppliers/create');
        }else{
            //print_r($_POST);
            $data['first_name'] = $this->input_params['first_name'];
            $data['last_name'] = $this->input_params['last_name'];
            $data['email'] = $this->input_params['email'];
            $data['mobile_no'] = $this->input_params['mobile_no'];
            $data['gst_no'] = $this->input_params['gst_no'];
            $data['created'] = date('Y-m-d H:i:s');
           
            $get_email = $this->general->get_details_by_single_column('suppliers','email',$this->input_params['email']);
            if($get_email->num_rows() > 0)
            {
                $this->session->set_flashdata('error', 'Email you have entered is already exist. Please enter another email address.');
                redirect(base_url().'Suppliers/create');

            }
            else{
                $this->general->insert('suppliers',$data);
                $this->session->set_flashdata('success','Suppliers added successfully.');
                redirect(base_url().'Suppliers/list');
            }
           
        }
    }
    
    function edit($id)
    {
        $user = $this->general->get_details_by_multi_columns('suppliers',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit Suppliers';
            $data['beadcrum_title'] = 'Suppliers';
            $data['beadcrum_sub_title'] = 'Edit Suppliers';
            $data['active']= 'Suppliers';
            $data['page']= 'admin/suppliers/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('suppliers',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('first_name','first name','trim|required');
        $this->form_validation->set_rules('last_name','last Name','trim|required');
        $this->form_validation->set_rules('email',' email','trim|required');
        $this->form_validation->set_rules('mobile_no',' mobile','trim|required');
        $this->form_validation->set_rules('gst_no',' GST NO','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Suppliers/edit/'.$id);
        }else{
            //print_r($_POST);
            $data['first_name'] = $this->input_params['first_name'];
            $data['last_name'] = $this->input_params['last_name'];
            $data['email'] = $this->input_params['email'];
            $data['gst_no'] = $this->input_params['gst_no'];
            $data['mobile_no'] = $this->input_params['mobile_no'];
            $data['modified'] = date('Y-m-d H:i:s');
           
            $get_email = $this->general->get_details_by_single_column('suppliers','email',$this->input_params['email']);
            if($get_email->num_rows() > 0)
            {
                $this->session->set_flashdata('error', 'Email you have entered is already exist. Please enter another email address.');
               redirect(base_url().'Suppliers/edit/'.$id);

            }
            else{
                $this->general->update('suppliers','id',$id,$data);
                $this->session->set_flashdata('success','Suppliers details updated successfully.');
                redirect(base_url().'Suppliers/list');

            }
           
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('suppliers','id',$id,$data);
            $this->session->set_flashdata('success','Suppliers  deleted successfully.');

            redirect(base_url().'Suppliers/list');
        }
        abort(404);
    }
}
?>