<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Unit extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Unit';
        $this->load->vars($data);
    }
    
    function unit_list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Unit/unit_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('unit',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $items = $this->general->fetch_unit($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        //$items = $this->general->get_details_by_multi_columns('unit',array('status'=>1));
        if(!empty($items))
        {
            $i=1;
            foreach($items as $r)
            {
                $data['items'][$i]['id']=$r->id;
                $data['items'][$i]['unit_name']=$r->unit_name;
                $data['items'][$i]['date_added']=$r->date_added;
                $data['items'][$i]['date_modified']=$r->date_modified;
                $i++;    
            }
        }
        else
        {
           $data['items'] = array(); 
        }
        $data['title'] = 'Units';
        $data['beadcrum_title'] = 'Unit List';
        $data['beadcrum_sub_title'] = 'Unit List';
        $data['active']= 'Unit';
        $data['page']= 'admin/Unit/unit_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function unit_create()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Unit';
        $data['beadcrum_title'] = 'Unit';
        $data['beadcrum_sub_title'] = 'Create Unit';
        $data['active']= 'Unit';
        $data['page']= 'admin/Unit/unit_create';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function unit_store()
    {
        $this->form_validation->set_rules('unit_name','unit code no','trim|required');
      
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Unit/unit_create');
        }else
        {          
                $data['unit_name'] = $this->input_params['unit_name'];
                $data['date_added'] = date('Y-m-d H:i:s');            
                $this->general->insert('unit',$data);
                $this->session->set_flashdata('success','Unit added successfully.');
                redirect(base_url().'Unit/unit_create');
                
        }         
        
    }

    function unit_edit($id)
    {
        $unit_list = $this->general->get_details_by_multi_columns('unit',array('id'=>$id))->row();
        if($unit_list)
        {
            $data['row']=$unit_list;
            $data['title'] = 'Edit Units';
            $data['beadcrum_title'] = 'Unit';
            $data['beadcrum_sub_title'] = 'Edit Unit';
            $data['active']= 'Unit';
            $data['page']= 'admin/Unit/unit_edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function unit_update($id)
    {
        $compny = $this->general->get_details_by_multi_columns('unit',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('unit_name','Warehouses Name','trim|required');
      
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Unit/unit_edit'.$id);
        }
        else
        {
            $data['unit_name'] = $this->input_params['unit_name'];
            $data['date_modified'] =date('Y-m-d H:i:s');

            $this->general->update('unit','id',$id,$data);
            $this->session->set_flashdata('success','Unit  updated successfully.');
            redirect(base_url().'Unit/unit_list');

           
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('unit','id',$id,$data);
            redirect(base_url().'Warehouses/warehouse_list');
        }
        abort(404);
    }
}
?>