<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class User extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | User';
        $this->load->vars($data);
    }
    
    function user_list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "User/user_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('users',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $user_data = $this->general->fetch_users($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();
        // $user_data = $this->general->get_details_by_multi_columns('users',array('status'=>1));
        if(!empty($user_data))
        {
            $i=1;
            foreach($user_data as $r)
            {
                $data['user_data'][$i]['id']=$r->id;
                $data['user_data'][$i]['username']=$r->username;
                $data['user_data'][$i]['first_name']=$r->first_name;
                $data['user_data'][$i]['last_name']=$r->last_name;
                $data['user_data'][$i]['email']=$r->email;
                $data['user_data'][$i]['mobile']=$r->mobile;
                $data['user_data'][$i]['date_created']=$r->date_created;
                $data['user_data'][$i]['date_modified']=$r->date_modified;
                $data['user_data'][$i]['status']=$r->status;

                $i++;    
            }
        }
        else
        {
           $data['user_data'] = array(); 
        }
        $data['title'] = 'Users List';
        $data['beadcrum_title'] = 'Users List';
        $data['beadcrum_sub_title'] = 'Users List';
        $data['active']= 'User';
        $data['page']= 'admin/user/user_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create_user()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Users';
        $data['beadcrum_title'] = 'Users';
        $data['beadcrum_sub_title'] = 'Create Users';
        $data['active']= 'User';
        $data['page']= 'admin/user/create_user';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {
        $this->form_validation->set_rules('username','user Name','trim|required');
        $this->form_validation->set_rules('first_name','user Name','trim|required');
        $this->form_validation->set_rules('last_name','user Name','trim|required');
        $this->form_validation->set_rules('email','user email','trim|required');
        $this->form_validation->set_rules('access_level','user access level','trim|required');
        $this->form_validation->set_rules('mobile','user mobile','trim|required');
        $this->form_validation->set_rules('password', 'Password', 'required');
        $this->form_validation->set_rules('confirm_password', 'Confirm password', 'required|matches[password]');

        //$this->form_validation->set_rules('date_added','create date','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'User/create_user');
        }else{
            //print_r($_POST);
            $data['username'] = $this->input_params['username'];
            $data['first_name'] = $this->input_params['first_name'];
            $data['last_name'] = $this->input_params['last_name'];
            $data['email'] = $this->input_params['email'];
            $data['access_level'] = $this->input_params['access_level'];
            $data['mobile'] = $this->input_params['mobile'];
            $data['password'] = md5(md5($this->input_params['password']));
            $data['date_created'] = date('Y-m-d H:i:s');
            if($this->input_params['password'] != $this->input_params['confirm_password'])
            {   
                $this->session->set_flashdata('error', 'Password and Confirm password must be same.');
                $this->session->set_flashdata('post_data',$this->input_params);
                redirect(base_url().'User/create_user');
            
            }
            $get_email = $this->general->get_details_by_single_column('users','email',$this->input_params['email']);
            if($get_email->num_rows() > 0)
            {
                $this->session->set_flashdata('error', 'Email you have entered is already exist. Please enter another email address.');
                redirect(base_url().'User/create_user');

            }
            else{
                $this->general->insert('users',$data);
                $this->session->set_flashdata('success','User added successfully.');
                redirect(base_url().'User/user_list');
            }
           
        }
    }
    
    function edit_user($id)
    {
        $user = $this->general->get_details_by_multi_columns('users',array('id'=>$id))->row();
        if($user)
        {
            $data['row']=$user;
            $data['title'] = 'Edit User';
            $data['beadcrum_title'] = 'User';
            $data['beadcrum_sub_title'] = 'Edit User';
            $data['active']= 'User';
            $data['page']= 'admin/user/edit_user';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update_user($id)
    {
        $user_details = $this->general->get_details_by_multi_columns('users',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('username','user Name','trim|required');
        $this->form_validation->set_rules('first_name','first name','trim|required');
        $this->form_validation->set_rules('last_name','user Name','trim|required');
        $this->form_validation->set_rules('email','user email','trim|required');
        $this->form_validation->set_rules('mobile','user mobile','trim|required');
        $this->form_validation->set_rules('access_level','user access level','trim|required');

        // $this->form_validation->set_rules('password', 'Password', 'required');
        // $this->form_validation->set_rules('confirm_password', 'Confirm password', 'required|matches[password]');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'User/edit_user/'.$id);
        }else{
            //print_r($_POST);
            $data['username'] = $this->input_params['username'];
            $data['first_name'] = $this->input_params['first_name'];
            $data['last_name'] = $this->input_params['last_name'];
            $data['email'] = $this->input_params['email'];
            $data['access_level'] = $this->input_params['access_level'];
            $data['mobile'] = $this->input_params['mobile'];
            $data['password'] = md5(md5($this->input_params['password']));
            $data['date_modified'] = date('Y-m-d H:i:s');
            // if($this->input_params['password'] != $this->input_params['confirm_password'])
            // {   
            //     $this->session->set_flashdata('error', 'Password and Confirm password must be same.');
            //     $this->session->set_flashdata('post_data',$this->input_params);
            //     redirect(base_url().'User/edit_user/'.$id);
            
            // }
            $get_email = $this->general->get_details_by_single_column('users','email',$this->input_params['email']);
            if($get_email->num_rows() > 0)
            {
                $this->session->set_flashdata('error', 'Email you have entered is already exist. Please enter another email address.');
               redirect(base_url().'User/edit_user/'.$id);

            }
            else{
                $this->general->update('users','id',$id,$data);
                $this->session->set_flashdata('success','User  updated successfully.');
                redirect(base_url().'User/user_list');

            }
           
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('users','id',$id,$data);
            $this->session->set_flashdata('success','User  deleted successfully.');

            redirect(base_url().'User/user_list');
        }
        abort(404);
    }
}
?>