<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/**
* This controller included Testing purpose
* 
* Created : 18/02/2020
* Created By : Shivani Vakil
* 
* 
* 
*/
class Warehouses extends MY_Controller {
    
    public $input_params;
    
    public function __construct() {
        parent::__construct();
        check_admin();
        $data['web_title'] = 'Admin | Warehouses';
        $this->load->vars($data);
    }
    
    function warehouse_list()
    {
        $this->load->library("pagination");
        $config = array();
        $config["base_url"] = base_url() . "Warehouses/warehouse_list";
        $config["total_rows"] =$this->general->get_details_by_multi_columns('warehouse',array('status'=>1))->num_rows();
        $config["per_page"] = 10;
        $config["uri_segment"] = 3;
        $this->pagination->initialize($config);
        $page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $user_data = $this->general->fetch_warehouse($config["per_page"],$page);
        $data["links"] = $this->pagination->create_links();

        // $user_data = $this->general->get_details_by_multi_columns('warehouse',array('status'=>1));
        if(!empty($user_data))
        {
            $i=1;
            foreach($user_data as $r)
            {
                $data['user_data'][$i]['id']=$r->id;
                $data['user_data'][$i]['name']=$r->name;
                $data['user_data'][$i]['parent_unit']=$r->parent_unit;
                $data['user_data'][$i]['address']=$r->address;
                $data['user_data'][$i]['street']=$r->street;
                $data['user_data'][$i]['landmark']=$r->landmark;
                $data['user_data'][$i]['city']=$r->city;
                $data['user_data'][$i]['state']=$r->state;
                $data['user_data'][$i]['country_id']=$r->country_id;
                $data['user_data'][$i]['email']=$r->email;
                $data['user_data'][$i]['phone_no']=$r->phone_no;
                $data['user_data'][$i]['status']=$r->status;
                $data['user_data'][$i]['date_added']=$r->date_added;
                $data['user_data'][$i]['date_modified']=$r->date_modified;
                $i++;    
            }
        }
        else
        {
           $data['user_data'] = array(); 
        }
        $data['title'] = 'warehouse List';
        $data['beadcrum_title'] = 'warehouse List';
        $data['beadcrum_sub_title'] = 'warehouse List';
        $data['active']= 'Warehouses';
        $data['page']= 'admin/warehouses/warehouse_list';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function create_house()
    {
        //$data['web_title'] = 'Admin | Category';
        $data['title'] = 'Create Warehouses';
        $data['beadcrum_title'] = 'Warehouses';
        $data['beadcrum_sub_title'] = 'Create Warehouses';
        $data['active']= 'Warehouses';
        $data['country_list'] = $this->general->get_details_by_multi_columns('location',array('status'=>1))->result();
        $data['page']= 'admin/warehouses/create_house';
        $this->load->vars($data);
        $this->load->view($this->_container);
    }
    
    function store()
    {
        $this->form_validation->set_rules('name','Warehouses Name','trim|required');
        $this->form_validation->set_rules('parent_unit','Warehouses parent_unit','trim|required');
        $this->form_validation->set_rules('address','Warehouses address','trim|required');
        $this->form_validation->set_rules('street','Warehouses street','trim|required');
        $this->form_validation->set_rules('landmark','Warehouses landmark','trim|required');
        $this->form_validation->set_rules('city','Warehouses city','trim|required');
        $this->form_validation->set_rules('state','Warehouses state','trim|required');
        //$this->form_validation->set_rules('country_id','Warehouses country_id','trim|required');
        $this->form_validation->set_rules('email','Warehouses email','trim|required');
        $this->form_validation->set_rules('phone_no','Warehouses phone_no','trim|required');

        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Warehouses/create_house');
        }else
        {          
                $data['name'] = $this->input_params['name'];
                $data['parent_unit'] = $this->input_params['parent_unit'];
                $data['address'] = $this->input_params['address'];
                $data['street'] = $this->input_params['street'];
                $data['landmark'] = $this->input_params['landmark'];
                $data['city'] = $this->input_params['city'];
                $data['state'] = $this->input_params['state'];
                $data['country_id'] = $this->input_params['country_id'];
                $data['email'] = $this->input_params['email'];
                $data['phone_no'] = $this->input_params['phone_no'];

                $data['date_added'] = date('Y-m-d H:i:s');
                //$data['ci_listing'] = $this->general->get_details_by_multi_columns('location',array('status'=>1));
                $get_camp_name = $this->general->get_details_by_single_column('warehouse','email',$this->input_params['email']);
                if($get_camp_name->num_rows() > 0)
                {
                    $this->session->set_flashdata('error','email address is already exist.Please enter another email address ');
                    redirect(base_url().'Warehouses/create_house');
    
                }
                $get_ware_name = $this->general->get_details_by_single_column('warehouse','name',$this->input_params['name']);

                if($get_ware_name->num_rows() > 0)
                {
                    $this->session->set_flashdata('error','warehouse name is already exist.Please enter another warehouse name ');
                    redirect(base_url().'Warehouses/create_house');
    
                }
                else{
                $this->general->insert('warehouse',$data);
                $this->session->set_flashdata('success','Warehouses added successfully.');
                redirect(base_url().'Warehouses/warehouse_list');
                }
                
        }

           
        
    }
    
    function edit($id)
    {
        $warehouses_list = $this->general->get_details_by_multi_columns('warehouse',array('id'=>$id))->row();
        if($warehouses_list)
        {
            $data['row']=$warehouses_list;
            $data['title'] = 'Edit warehouses';
            $data['beadcrum_title'] = 'warehouses';
            $data['beadcrum_sub_title'] = 'Edit warehouses';
            $data['active']= 'Warehouses';
            $data['page']= 'admin/warehouses/edit';
            $this->load->vars($data);
            $this->load->view($this->_container);
        }else{
           abort(404);
        }
    }
    
    function update($id)
    {
        $compny = $this->general->get_details_by_multi_columns('warehouse',array('id'=>$id))->row();
        //print_r($category->category);exit;
        $this->form_validation->set_rules('name','Warehouses Name','trim|required');
        $this->form_validation->set_rules('parent_unit','Warehouses parent_unit','trim|required');
        $this->form_validation->set_rules('address','Warehouses address','trim|required');
        $this->form_validation->set_rules('street','Warehouses street','trim|required');
        $this->form_validation->set_rules('landmark','Warehouses landmark','trim|required');
        $this->form_validation->set_rules('city','Warehouses city','trim|required');
        $this->form_validation->set_rules('state','Warehouses state','trim|required');
        $this->form_validation->set_rules('country_id','Warehouses country_id','trim|required');
        $this->form_validation->set_rules('email','Warehouses email','trim|required');
        $this->form_validation->set_rules('phone_no','Warehouses phone_no','trim|required');
        if($this->form_validation->run() == false)
        {
            $this->session->set_flashdata('post_data',$this->input_params);
            $this->session->set_flashdata('error',validation_errors());
            redirect(base_url().'Warehouses/edit'.$id);
        }else{
            //print_r($_POST);
            $data['name'] = $this->input_params['name'];
            $data['parent_unit'] = $this->input_params['parent_unit'];
            $data['address'] = $this->input_params['address'];
            $data['street'] = $this->input_params['street'];
            $data['landmark'] = $this->input_params['landmark'];
            $data['city'] = $this->input_params['city'];
            $data['state'] = $this->input_params['state'];
            $data['country_id'] = $this->input_params['country_id'];
            $data['email'] = $this->input_params['email'];
            $data['phone_no'] = $this->input_params['phone_no'];
            $data['date_modified'] =date('Y-m-d H:i:s');
            $get_camp_name = $this->general->get_details_by_single_column('warehouse','email',$this->input_params['email']);
            if($get_camp_name->num_rows() > 0)
            {
                $this->session->set_flashdata('error','email address is already exist.Please enter another email address ');
                redirect(base_url().'Warehouses/edit/'.$id);
            }
            $get_ware_name = $this->general->get_details_by_single_column('warehouse','name',$this->input_params['name']);
            if($get_ware_name->num_rows() > 0)
            {
            $this->session->set_flashdata('error','warehouse name is already exist.Please enter another warehouse name ');
            redirect(base_url().'Warehouses/edit/'.$id);

            }
            else{
                $this->general->update('warehouse','id',$id,$data);
                $this->session->set_flashdata('success','Company  updated successfully.');
                redirect(base_url().'Warehouses/warehouse_list');
            }
           
        }
    }
    function delete($id)
    {
        if($id)
        {
            $data['status'] = 0;
            $this->general->update('warehouse','id',$id,$data);
            redirect(base_url().'Warehouses/warehouse_list');
        }
        abort(404);
    }
}
?>