<?php
class Common extends CI_Model
{

    function insert($table_name,$data)
    {
        $this->db->insert("$table_name",$data);
        return $this->db->insert_id();
    }
    function insert_batch($table_name,$data)
    {
        $this->db->insert_batch("$table_name",$data);
        return $this->db->insert_id();

    }
    function update($table_name,$fiels_name,$field_val,$data)
    {
        $this->db->where("$fiels_name",$field_val);
        $this->db->update("$table_name",$data);
        return $this->db->affected_rows();
    }
    function delete($table_name,$fiels_name,$field_val)
    {
        $this->db->where("$fiels_name",$field_val);
        $this->db->delete("$table_name");
    }
    function get_details_by_single_column($table_name,$fiels_name,$field_val)
    {
        $this->db->select('*');
        $this->db->where("$fiels_name",$field_val);
        return $this->db->get("$table_name");
    }
    function get_details_by_multi_columns($table_name,$field_array=array(),$orderBy='DESC',$orderByColumn='id')
    {
        $this->db->select('*');

        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where($field_name,$field_val);
        }
        
        $this->db->order_by($orderByColumn,$orderBy);

        return $this->db->get("$table_name");
    }
    function get_details_by_multi_columns_where_not($table_name,$field_array_not_in=array(),$field_array=array(),$orderBy='DESC',$orderByColumn='id')
    {   
        $this->db->select('*');

        if(!empty($field_array_not_in))
        {
            foreach($field_array_not_in as $field_name_not_in=>$field_val_not_in)
            $this->db->where_not_in($field_name_not_in,$field_val_not_in);
        }
        
        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where($field_name,$field_val);
        }
        
        $this->db->order_by($orderByColumn,$orderBy);

        return $this->db->get("$table_name");
    }
    function get_avg_data($table_name,$column_name,$field_array)
    {
        $this->db->select("AVG($column_name) avg_filed");
        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where($field_name,$field_val);
        }
        return $this->db->get("$table_name")->row();
    }
    function get_details_by_multi_columns_array($table_name,$field_array,$orderBy='DESC',$orderByColumn='id')
    {
        $this->db->select('*');

        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where_in($field_name,$field_val);
        }
        
        $this->db->order_by($orderByColumn,$orderBy);

        return $this->db->get("$table_name");
    }
    
    function get_details_by_multi_columns_pagination_array($table_name,$field_array=array(),$page=-1,$limit=NULL,$search_array=array(),$orderBy='DESC',$orderByColumn='id')
    {
        $this->db->select('*');

        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where_in($field_name,$field_val);
        }
        if(!empty($search_array))
        {
            foreach($search_array as $search_name=>$search_val)
            {
                $this->db->like($search_name,$search_val);
            }
        }
        if($page != -1)
        {
            $this->db->limit($limit,$page);
        }
        $this->db->order_by($orderByColumn,$orderBy);

        return $this->db->get("$table_name");
    }
    function get_college_students($college_id,$field_array=array(),$page=-1,$limit=NULL,$search_array=array())
    {
        $this->db->select('users.*,colleges.college_name,colleges.slug,students.college_id');
        $this->db->where('users.role',2);
        $this->db->where('students.college_id',$college_id);
        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where_in($field_name,$field_val);
        }
        if(!empty($search_array))
        {
            foreach($search_array as $search_name=>$search_val)
            {
                $this->db->like($search_name,$search_val);
            }
        }
        $this->db->join("users","users.id=students.user_id");
        $this->db->join("colleges","colleges.id=students.college_id");
        
        if($page != -1)
        {
            $this->db->limit($limit,$page);
        }
        $this->db->order_by('users.id','desc');

        return $this->db->get("students");
    }
    function get_data_between_two_dates($table_name,$field_array,$date_column,$from_date,$to_date)
    {
        $this->db->select('*');

        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where_in($field_name,$field_val);
        }
        
        $this->db->where("$date_column >=" , $from_date);
        $this->db->where("$date_column <=" , $to_date);
        
        return $this->db->get("$table_name");
    }
    function get_details_using_or($table_name,$and_field_array,$or_field_array,$orderBy='DESC',$orderByColumn='id')
    {
        $this->db->select('*');
        $this->db->where($and_field_array);
        $this->db->group_start();
        $this->db->where($or_field_array);
        $this->db->group_end();
        $this->db->order_by($orderByColumn,$orderBy);
        return $this->db->get("$table_name");
    }
    function get_data_two_table_join($table1,$table2,$join_column_table1,$join_column_table2,$field_array,$orderBy='DESC',$orderByColumn='id')
    {
        $this->db->select("$table1.*,$table2.*,$table1.id as id1,$table2.id as id2");

        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where($field_name,$field_val);
        }
         $this->db->join("$table2","$join_column_table1=$join_column_table2");

         //$this->db->join('questions','questions.id=feedbacks.question_id');

         $this->db->order_by($table1.'.'.$orderByColumn,$orderBy);
        return $this->db->get($table1);

    }
    function get_all_foods($lat=NULL,$lng=NULL,$distance=NULL,$cat_ids=NULL,$page=NULL,$per_page=NULL,$search_text='',$food_type='')
    {
        $query = $this->get_all_global($lat,$lng,$distance,-1,NULL,0,$cat_ids,$search_text,$food_type);
        if($query['count'] > 0)
        {
            $query2 = $this->get_all_global($lat,$lng,$distance,$page,$per_page,$query['count'],$cat_ids,$search_text,$food_type);
            $data['result'] = $query2;
        }else{
            $data['result'] = array();
        }
        return $data;
    }
    function get_add_to_cart_products($table1,$table2,$join_column_table1,$join_column_table2,$field_array,$orderBy='DESC',$orderByColumn='id')
    {
        $this->db->select("$table1.*,$table2.*,$table1.id as id1,$table2.id as id2,$table1.price as price,$table2.price as price2");

        if(!empty($field_array))
        {
            foreach($field_array as $field_name=>$field_val)
            $this->db->where($field_name,$field_val);
        }
         $this->db->join("$table2","$join_column_table1=$join_column_table2");

         //$this->db->join('questions','questions.id=feedbacks.question_id');

         $this->db->order_by($table1.'.'.$orderByColumn,$orderBy);
        return $this->db->get($table1);

    }
    
    function get_all_global($lat=NULL,$lng=NULL,$distance=NULL,$page=-1,$per_page=NULL,$num_rows=0,$cat_ids=NULL,$search_text=NULL,$food_type=NULL)
    {
        if((!empty($lat)) && (!empty($lng)))
        {
            $this->db->select("food_details.*,( 6371 * acos( cos( radians($lat) ) * cos( radians(food_details.lat ) ) * cos( radians(food_details.lng ) - radians($lng) ) + sin( radians($lat) ) * sin( radians( food_details.lat ) ) ) ) AS product_distance", false);
            $this->db->select("categories.category,categories.image,categories.r_category");
            //$this->db->having('product_distance <= '.$distance);
        }else{
            $this->db->select("food_details.*");
            $this->db->select("categories.category,categories.image");
        }
        $this->db->where('food_details.active',1);
        $this->db->where('food_details.is_available',1);
        $this->db->where('food_details.in_offer',0);
        
        if(!empty($cat_ids))
        {
          $this->db->where_in('food_details.category_id',$cat_ids);
        }
        
        if(!empty($search_text))
        {
          $this->db->like('food_details.food_name',$search_text);
          $this->db->or_like('food_details.description',$search_text);
        }
        
        if(!empty($food_type))
        {
            $this->db->where('food_details.food_type',$food_type);
        }
        if((!empty($lat)) && (!empty($lng)))
        {
           $this->db->order_by('product_distance','asc'); 
        }else{
            $this->db->order_by('food_details.id','desc'); 
        }
        
        if($page != -1)
        {
            $this->load->library("pagination");
            $config = array();
            $config["total_rows"] = $num_rows;
            $config["per_page"] = $per_page;
            $this->pagination->initialize($config);
            $total_page = ceil($num_rows / $per_page);
            $offSet = $page * $per_page;
            $this->db->limit($per_page, $offSet);
        }
        
        $this->db->join('categories','food_details.category_id=categories.id','left');
        
        $query = $this->db->get('food_details');
        
        if($page != -1)
        {
            $total_page = $total_page;
        } else {
            $total_page = '';
        }
        
        if($query->num_rows() > 0)
        {
            return array('count'=>$query->num_rows(),'total_page'=>$total_page,'result'=>$query->result());
        }else{
            return array('count'=>0,'total_page'=>'','result'=>array());
        }
        
    }

}
?>